/******************************/
/* LN^f[^ϊ */
/******************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	CHRWIDTH	64
#define	CHRHEIGHT	32
#define	MAXCHARA	80

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;
	FILE	*patfp;

	unsigned char	pixel[CHRWIDTH][CHRHEIGHT][MAXCHARA];

	int		width,height;
	int		x,y,z,c;
	int		i,j;
	int		sft;
	int		a0,a1;
	int		cnum;
	int		size;
	int		chr_width,chr_height;
	int		offset;
	int		sflag;

	if (argc != 6 && argc != 7) {
		fprintf(stderr, "Usage: convchara infile outfile offset size cha_number [-s]\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	offset = atoi(argv[3]);
	size = atoi(argv[4]);
	cnum = atoi(argv[5]);

	sflag = 0;
	if (argc == 7) {
		if (strcmp(argv[6],"-s") != 0) {
			fprintf(stderr, "Usage: convchara infile outfile offset size cha_number [-s]\n");
			exit(1);
		}
		sflag = 1;
	}

	fseek(infp,4+offset,SEEK_SET);

	switch (size) {
		case 2:
			chr_width  = 16;
			chr_height =  8;
			break;
		case 3:
			chr_width  = 32;
			chr_height = 16;
			break;
		case 4:
			chr_width  = 64;
			chr_height = 32;
			break;
		default:
			fprintf(stderr,"Illigal size %d : size = 2-4\n",size);
			exit(1);
	}


	for (z = 0;z < MAXCHARA;z ++) {
		for (y = 0;y < chr_height;y ++) {
			for (x = 0;x < chr_width;x ++) {
				pixel[x][y][z] = 0x00;
			}
		}
	}


	z = 0;
	y = 0;
	x = 0;
	c = 0x09;
	while ( (a0 = fgetc(infp)) != EOF) {

		sft = 0x80;
		for (i = 0;i < 8;i ++) {
			a1 = ( (a0 & sft) != 0x00) ? c : 0x08;
			pixel[x+i][y][z] |= a1;
			sft /= 2;
		}

		x += 8;
		if (x >= chr_width) {
			x = 0;
			y ++;
			if (y >= chr_height) {
				y = 0;
				if (c == 0x09) {
					c = 0x0a;
				} else {
					c = 0x09;
					z ++;

					if (z >= cnum) {
						break;
					}
				}
			}
		}
	}

	if (sflag != 0) {

		for (z = 0;z < cnum;z ++) {
			for (x = 0;x < chr_width;x += 8) {
				for (y = 0;y < chr_height;y += 2) {

					a1 = 0;
					for (i = 0;i < 8;i ++) {
						a0 = ( ((pixel[x+i][y+0][z] & 0x03) != 0x00) ? 0x01 : 0x00);
						a1 = a1 * 2 + a0;
					}
					fputc(a1,outfp);

					a1 = 0;
					for (i = 0;i < 8;i ++) {
						a0 = ( ((pixel[x+i][y+0][z] & 0x03) != 0x00) ? 0x01 : 0x00);
						a1 = a1 * 2 + a0;
					}
					fputc(a1,outfp);

					a1 = 0;
					for (i = 0;i < 8;i ++) {
						a0 = ( ((pixel[x+i][y+1][z] & 0x03) != 0x00) ? 0x01 : 0x00);
						a1 = a1 * 2 + a0;
					}
					fputc(a1,outfp);

					a1 = 0;
					for (i = 0;i < 8;i ++) {
						a0 = ( ((pixel[x+i][y+1][z] & 0x03) != 0x00) ? 0x01 : 0x00);
						a1 = a1 * 2 + a0;
					}
					fputc(a1,outfp);

				}
			}
		}

	} else {

		for (z = 0;z < cnum;z ++) {
			for (y = 0;y < chr_height;y += 2) {
				for (x = 0;x < chr_width;x += 8) {

					a1 = 0;
					for (i = 0;i < 8;i ++) {
						a0 = ( ((pixel[x+i][y+0][z] & 0x02) != 0x00) ? 0x01 : 0x00);
						a1 = a1 * 2 + a0;
					}
					fputc(a1,outfp);

					a1 = 0;
					for (i = 0;i < 8;i ++) {
						a0 = ( ((pixel[x+i][y+0][z] & 0x01) != 0x00) ? 0x01 : 0x00);
						a1 = a1 * 2 + a0;
					}
					fputc(a1,outfp);

					a1 = 0;
					for (i = 0;i < 8;i ++) {
						a0 = ( ((pixel[x+i][y+1][z] & 0x02) != 0x00) ? 0x01 : 0x00);
						a1 = a1 * 2 + a0;
					}
					fputc(a1,outfp);

					a1 = 0;
					for (i = 0;i < 8;i ++) {
						a0 = ( ((pixel[x+i][y+1][z] & 0x01) != 0x00) ? 0x01 : 0x00);
						a1 = a1 * 2 + a0;
					}
					fputc(a1,outfp);

				}
			}
		}

	}

	fclose(outfp);
	fclose(infp);

	return(0);
}


