/******************************/
/* LN^f[^ϊ */
/******************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	CHRWIDTH	64
#define	CHRHEIGHT	32
#define	MAXCHARA	32

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;
	FILE	*patfp;

	unsigned char	pixel[CHRWIDTH][CHRHEIGHT][MAXCHARA];

	int		width,height;
	int		x,y,z,c;
	int		i,j;
	int		sft;
	int		a0,a1;
	int		cnum;
	int		size;
	int		chr_width,chr_height;
	int		offset;

	if (argc != 6) {
		fprintf(stderr, "Usage: convchara infile outfile offset size cha_number\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	offset = atoi(argv[3]);
	size = atoi(argv[4]);
	cnum = atoi(argv[5]);

	switch (size) {
		case 0:
			chr_width  =  8;
			chr_height =  4;
			break;
		case 1:
			chr_width  =  8;
			chr_height =  8;
			break;
		case 2:
			chr_width  =  16;
			chr_height =  8;
			break;
		case 3:
			chr_width  =  8;
			chr_height =  16;
			break;
		default:
			fprintf(stderr,"Illigal size %d : size = 0-3\n",size);
			exit(1);
	}


	for (z = 0;z < MAXCHARA;z ++) {
		for (y = 0;y < chr_height;y ++) {
			for (x = 0;x < chr_width;x ++) {
				pixel[x][y][z] = 0x00;
			}
		}
	}


	fseek(infp,4+offset,SEEK_SET);

	z = 0;
	y = 0;
	x = 0;
	c = 0x09;
	while ( (a0 = fgetc(infp)) != EOF) {

		sft = 0x80;
		for (i = 0;i < 8;i ++) {
			a1 = ( (a0 & sft) != 0x00) ? c : 0x08;
			pixel[x+i][y][z] |= a1;
			sft /= 2;
		}

		x += 8;
		if (x >= chr_width) {
			x = 0;
			y ++;
			if (y >= chr_height) {
				y = 0;
				z ++;

				if (z >= cnum) {
					z = 0;
					if (c == 0x09) {
						c = 0x0a;
						fseek(infp,4+offset+0x0180*1,SEEK_SET);
					} else if (c == 0x0a) {
						c = 0x0c;
						fseek(infp,4+offset+0x0180*2,SEEK_SET);
					} else {
						break;
					}
				}


			}
		}
	}

	for (z = 0;z < cnum;z ++) {
		for (y = 0;y < chr_height;y ++) {
			for (x = 0;x < chr_width;x ++) {

				if (pixel[x][y][z] == 0x0b) {		/*  */
					pixel[x][y][z] = 0x0f;
				}

				if (pixel[x][y][z] == 0x0d) {		/* F */
					pixel[x][y][z] = 0x09;
				}

			}
		}
	}

	for (z = 0;z < cnum;z ++) {
		for (y = 0;y < chr_height;y += 2) {
			for (x = 0;x < chr_width;x += 8) {

				a1 = 0;
				for (i = 0;i < 8;i ++) {
					a0 = ( ((pixel[x+i][y+0][z] & 0x02) != 0x00) ? 0x01 : 0x00);
					a1 = a1 * 2 + a0;
				}
				fputc(a1,outfp);

				a1 = 0;
				for (i = 0;i < 8;i ++) {
					a0 = ( ((pixel[x+i][y+0][z] & 0x01) != 0x00) ? 0x01 : 0x00);
					a1 = a1 * 2 + a0;
				}
				fputc(a1,outfp);

				a1 = 0;
				for (i = 0;i < 8;i ++) {
					a0 = ( ((pixel[x+i][y+1][z] & 0x02) != 0x00) ? 0x01 : 0x00);
					a1 = a1 * 2 + a0;
				}
				fputc(a1,outfp);

				a1 = 0;
				for (i = 0;i < 8;i ++) {
					a0 = ( ((pixel[x+i][y+1][z] & 0x01) != 0x00) ? 0x01 : 0x00);
					a1 = a1 * 2 + a0;
				}
				fputc(a1,outfp);

			}
		}
	}


	fclose(outfp);
	fclose(infp);

	return(0);
}


