/********************************/
/* ʕ\vOs */
/********************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	BMPWIDTH	640
#define	BMPHEIGHT	200

void	emu88(unsigned char *, unsigned char *, unsigned char *, unsigned char *, int, FILE *);

int main(int argc, char **argv)
{
	FILE	*progfp;
	FILE	*infp;
	FILE	*outfp;

	unsigned char	pixel[BMPWIDTH][BMPHEIGHT];

	unsigned char	mainmem[0x10000];
	unsigned char	vram_b[0x4000];
	unsigned char	vram_r[0x4000];
	unsigned char	vram_g[0x4000];
	unsigned char	*vrampt;

	unsigned char	p6vram[0x8000];

	unsigned short int height, width;

	int		stadd, pradd;
	int		sft, a0, a1, a2, a3, c, col;
	int		i, j, k, n, x, y, yadd;
	int		rflag;

	if (argc != 6 && argc != 7) {
		fprintf(stderr, "Usage: drawprog progfile startadd progadd input_data output_data [-r]\n");
		exit(1);
	}


/* open files */

	if ((progfp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((infp = fopen(argv[4], "rb")) == NULL) {
		perror(argv[4]);
		exit(1);
	}

	if ((outfp = fopen(argv[5], "wb")) == NULL) {
		perror(argv[5]);
		exit(1);
	}

	rflag = 0;
	if (argc == 7) {
		if (strcmp(argv[6],"-r") != 0) {
			fprintf(stderr, "Usage: drawprog progfile startadd progadd input_data output_data [-r]\n");
			exit(1);
		}
		rflag = 1;
	}

	stadd = atoi(argv[2]);
	pradd = atoi(argv[3]);


/* initialize */

	height = BMPHEIGHT;
	width  = BMPWIDTH;

	for (i = 0;i < 0x10000; i ++) {
		mainmem[i] = 0xff;
	}

	for (i = 0;i < 0x4000; i ++) {
		vram_b[i] = 0xff;
		vram_r[i] = 0xff;
		vram_g[i] = 0xff;
	}


/* read progfile */

	i = stadd;
	while ( (a0 = fgetc(progfp)) != EOF) {
		mainmem[i] = a0;
		i ++;
	}


/* run program */

	emu88(mainmem, vram_b, vram_r, vram_g, pradd, infp);

/* conv color */

	for (y = 0;y < height;y ++) {
		for (x = 0;x < width;x ++) {
			pixel[x][y] = 0x08;
		}
	}

	for (col = 0x01;col < 0x08;col *= 2) {
		if (col == 0x01) {
			vrampt = vram_b;
		} else if (col == 0x02) {
			vrampt = vram_r;
		} else {
			vrampt = vram_g;
		}
		for (y = 0;y < height;y ++) {
			for (x = 0;x < width;x += 8) {
				c = *vrampt;
				vrampt ++;
				sft = 0x80;
				for (i = 0;i < 8;i ++) {
					if ( (c & sft) != 0) {
						pixel[x+i][y] |= col;
					}
					sft /= 2;
				}
			}
		}
	}

	for (y = 0;y < height;y ++) {
		for (x = 0;x < width;x ++) {
			switch (pixel[x][y]) {
				case 0x08:	/*  */
					pixel[x][y] = 0x08;	/*  */
					break;
				case 0x09:	/*  */
					pixel[x][y] = 0x05;	/* F */
					break;
				case 0x0a:	/*  */
					if (rflag != 0) {
						pixel[x][y] = 0x0f;	/*  */
					} else {
						pixel[x][y] = 0x0a;	/*  */
					}
					break;
				case 0x0b:	/*  */
					pixel[x][y] = 0x0f;	/*  */
					break;
				case 0x0c:	/*  */
					if (rflag != 0) {
						if ((x+y)%2!= 0) {
							pixel[x][y] = 0x0a;	/*  */
							break;
						} else {
							pixel[x][y] = 0x0f;	/*  */
							break;
						}
					} else {
						if ((x+y)%2!= 0) {
							pixel[x][y] = 0x0f;	/*  */
							break;
						} else {
							pixel[x][y] = 0x05;	/* F */
							break;
						}
					}
				case 0x0d:	/* F */
					if ((x+y)%2!= 0) {
						pixel[x][y] = 0x05;	/* F */
						break;
					} else {
						pixel[x][y] = 0x0f;	/*  */
						break;
					}
				case 0x0e:	/*  */
					if (rflag != 0) {
						if ((x+y)%2!= 0) {
							pixel[x][y] = 0x0f;	/*  */
							break;
						} else {
							pixel[x][y] = 0x05;	/* F */
							break;
						}
					} else {
						if ((x+y)%2!= 0) {
							pixel[x][y] = 0x0a;	/*  */
							break;
						} else {
							pixel[x][y] = 0x0f;	/*  */
							break;
						}
					}
				case 0x0f:	/*  */
					pixel[x][y] = 0x0f;	/*  */
					break;

				default:
					pixel[x][y] = 0x07;	/* D */
					break;
			}
		}
	}

/* VRAMɏ */
	for (i = 0;i < 0x8000;i ++) {
		p6vram[i] = 0x00;
	}

/* ʁi0x1a00`0x7dffj*/
	for (y = 0;y < height;y += 2) {
		for (x = 0;x < 512;x += 8) {
			a0 = 0;
			a1 = 0;
			a2 = 0;
			a3 = 0;
			for (i = 0;i < 8;i ++) {
				a0 *= 2;
				a1 *= 2;
				a2 *= 2;
				a3 *= 2;
				if ( (pixel[x+i][y+0] & 0x02) != 0) {
					a0 ++;
				}
				if ( (pixel[x+i][y+0] & 0x01) != 0) {
					a1 ++;
				}
				if ( (pixel[x+i][y+1] & 0x02) != 0) {
					a2 ++;
				}
				if ( (pixel[x+i][y+1] & 0x01) != 0) {
					a3 ++;
				}
			}
			p6vram[y*0x80+x/8*4+0x1a00+0] = a0;
			p6vram[y*0x80+x/8*4+0x1a00+1] = a1;
			p6vram[y*0x80+x/8*4+0x1a00+2] = a2;
			p6vram[y*0x80+x/8*4+0x1a00+3] = a3;
		}
	}

/* Eʁi0x0000`0x19ffj*/
	for (y = 0;y < height;y += 2) {
		a0 = (y & 0x02);			/* xxxx_xxxx xxxx_xx1x */
		a1 = (y & 0x0c);			/* xxxx_xxxx xxxx_32xx */
		a2 = (y & 0xf0);			/* xxxx_xxxx 7654_xxxx */
		a0 = (a0 <<  7);			/* xxxx_xxx1 xxxx_xxxx */
		a1 = (a1 <<  4);			/* xxxx_xxxx 32xx_xxxx */
		a2 = (a2 <<  5);			/* xxx7_654x xxxx_xxxx */
		yadd = a0|a1|a2;
		for (x = 512;x < width;x += 8) {
			a0 = 0;
			a1 = 0;
			a2 = 0;
			a3 = 0;
			for (i = 0;i < 8;i ++) {
				a0 *= 2;
				a1 *= 2;
				a2 *= 2;
				a3 *= 2;
				if ( (pixel[x+i][y+0] & 0x02) != 0) {
					a0 ++;
				}
				if ( (pixel[x+i][y+0] & 0x01) != 0) {
					a1 ++;
				}
				if ( (pixel[x+i][y+1] & 0x02) != 0) {
					a2 ++;
				}
				if ( (pixel[x+i][y+1] & 0x01) != 0) {
					a3 ++;
				}
			}
			p6vram[yadd+(x-512)/8*4+0] = a0;
			p6vram[yadd+(x-512)/8*4+1] = a1;
			p6vram[yadd+(x-512)/8*4+2] = a2;
			p6vram[yadd+(x-512)/8*4+3] = a3;
		}
	}

/* f[^o͂ */
	for (i = 0;i < 0x8000;i ++) {
		fputc(p6vram[i],outfp);
	}


	fclose(progfp);
	fclose(infp);
	fclose(outfp);

	return(0);
}

