/****************************/
/* PC-8801 ȈՃG~[^ */
/****************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/* Z80 register */

typedef union {
	unsigned short int word_reg;
	struct {
		unsigned char regl;
		unsigned char regh;
	} byte_reg;
} type_reg16;

type_reg16			regw_af;
type_reg16			regw_bc;
type_reg16			regw_de;
type_reg16			regw_hl;
type_reg16			regw_af_;
type_reg16			regw_bc_;
type_reg16			regw_de_;
type_reg16			regw_hl_;

#define reg_af	(regw_af.word_reg)
#define reg_bc	(regw_bc.word_reg)
#define reg_de	(regw_de.word_reg)
#define reg_hl	(regw_hl.word_reg)
#define reg_a	(regw_af.byte_reg.regh)
#define reg_f	(regw_af.byte_reg.regl)
#define reg_b	(regw_bc.byte_reg.regh)
#define reg_c	(regw_bc.byte_reg.regl)
#define reg_d	(regw_de.byte_reg.regh)
#define reg_e	(regw_de.byte_reg.regl)
#define reg_h	(regw_hl.byte_reg.regh)
#define reg_l	(regw_hl.byte_reg.regl)
#define reg_af_	(regw_af_.word_reg)
#define reg_bc_	(regw_bc_.word_reg)
#define reg_de_	(regw_de_.word_reg)
#define reg_hl_	(regw_hl_.word_reg)

#define	is_zflag	(reg_f & 0x40)
#define	is_cflag	(reg_f & 0x01)

unsigned short int	reg_pc;
unsigned short int	reg_sp;
//unsigned char		reg_i;
//unsigned char		reg_r;

unsigned short int	reg_ix;
unsigned short int	reg_iy;

typedef enum {
	r_mainmem, r_vram_b, r_vram_r, r_vram_g, r_vram_ex
} type_ramsel;

typedef enum {
	r_ramsp, r_ramex
} type_ramacc;

typedef struct {
	unsigned char *mainmem;
	unsigned char *vram_b;
	unsigned char *vram_r;
	unsigned char *vram_g;
	unsigned char port0x32;
	unsigned char port0x34;
	unsigned char port0x35;
	type_ramsel	ramsel;
	type_ramsel	ramacc;
} type_memacc;

type_memacc memacc;


unsigned char		readmemb(unsigned short int);
unsigned short int	readmemw(unsigned short int);
void				writememb(unsigned short int, unsigned char);
void				writememw(unsigned short int, unsigned short int);
unsigned char		readmemixb(unsigned char, unsigned short int);
void				writememixb(unsigned char, unsigned short int, unsigned char);
void				setixy(unsigned char, unsigned short int);
unsigned short int	reladd(unsigned short int);

void setcflag(void);
void clrcflag(void);
void setzflag(void);
void clrzflag(void);

void addregb(unsigned char);
void adcregb(unsigned char);
void subregb(unsigned char);
void sbcregb(unsigned char);
void andregb(unsigned char);
void orregb(unsigned char);
void xorregb(unsigned char);
void cpregb(unsigned char);
void rlcaregb(void);
void rrcaregb(void);
void rlaregb(void);
void rraregb(void);
unsigned char incregb(unsigned char);
unsigned char decregb(unsigned char);
unsigned char rlcregb(unsigned char);
unsigned char rrcregb(unsigned char);
unsigned char rlregb(unsigned char);
unsigned char rrregb(unsigned char);
unsigned char slaregb(unsigned char);
unsigned char srlregb(unsigned char);
unsigned char sraregb(unsigned char);

unsigned short int	addregw(unsigned short int, unsigned short int);
unsigned short int	adcregw(unsigned short int, unsigned short int);
unsigned short int	sbcregw(unsigned short int, unsigned short int);
unsigned short int	incregw(unsigned short int);
unsigned short int	decregw(unsigned short int);

void			bitregb(unsigned char, unsigned char);
unsigned char	resregb(unsigned char, unsigned char);
unsigned char	setregb(unsigned char, unsigned char);

void portout(unsigned char, unsigned char);

void	emu88(unsigned char *mainmem, unsigned char *vram_b, unsigned char *vram_r, unsigned char *vram_g, int pradd, FILE *infp)
{

	unsigned char		m0, m1, tmpb0;
	unsigned short int	tmpw0, reg_ixy;

	int		i,j;

	reg_pc = pradd;

	memacc.mainmem  = mainmem;
	memacc.vram_b   = vram_b;
	memacc.vram_r   = vram_r;
	memacc.vram_g   = vram_g;
	memacc.port0x32 = 0x00;
	memacc.port0x34 = 0x00;
	memacc.port0x35 = 0x00;
	memacc.ramsel   = r_mainmem;
	memacc.ramacc   = r_ramsp;

	reg_sp = 0x0000;
	reg_af = 0x0000;
	reg_bc = 0x0000;
	reg_de = 0x0000;
	reg_hl = 0x0000;
	reg_ix = 0x0000;
	reg_iy = 0x0000;

	for (;;) {

/* for debug */
/*
if (
	(reg_pc == 0xb8de) ||
	(reg_pc == 0xb8e0) ||
	(reg_pc == 0xb8f2) ||
	(reg_pc == 0xbb0b) ||
	(reg_pc == 0xbb11)
) {
	printf("register\n");
	printf(" AF :%04X   BC :%04X   DE :%04X   HL :%04X\n",reg_af, reg_bc, reg_de, reg_hl);
	printf(" AF':%04X   BC':%04X   DE':%04X   HL':%04X\n",reg_af_,reg_bc_,reg_de_,reg_hl_);
	printf(" IX :%04X   IY :%04X   PC :%04X   SP :%04X\n",reg_ix, reg_iy, reg_pc, reg_sp);
	printf("(HL):%04X  (BC):%04X  (DE):%04X  (SP):%04X\n",
		readmemw(reg_hl), readmemw(reg_bc), readmemw(reg_de), readmemw(reg_sp) );
}
*/

		m0 = readmemb(reg_pc);
		m1 = readmemb(reg_pc+1);
		switch (m0) {
		case 0x40: reg_b = reg_b; reg_pc++; break;									//	ld		b,b
		case 0x41: reg_b = reg_c; reg_pc++; break;									//	ld		b,c
		case 0x42: reg_b = reg_d; reg_pc++; break;									//	ld		b,d
		case 0x43: reg_b = reg_e; reg_pc++; break;									//	ld		b,e
		case 0x44: reg_b = reg_h; reg_pc++; break;									//	ld		b,h
		case 0x45: reg_b = reg_l; reg_pc++; break;									//	ld		b,l
		case 0x46: reg_b = readmemb(reg_hl); reg_pc++; break;						//	ld		b,(hl)
		case 0x47: reg_b = reg_a; reg_pc++; break;									//	ld		b,a
		case 0x48: reg_c = reg_b; reg_pc++; break;									//	ld		c,b
		case 0x49: reg_c = reg_c; reg_pc++; break;									//	ld		c,c
		case 0x4a: reg_c = reg_d; reg_pc++; break;									//	ld		c,d
		case 0x4b: reg_c = reg_e; reg_pc++; break;									//	ld		c,e
		case 0x4c: reg_c = reg_h; reg_pc++; break;									//	ld		c,h
		case 0x4d: reg_c = reg_l; reg_pc++; break;									//	ld		c,l
		case 0x4e: reg_c = readmemb(reg_hl); reg_pc++; break;						//	ld		c,(hl)
		case 0x4f: reg_c = reg_a; reg_pc++; break;									//	ld		c,a
		case 0x50: reg_d = reg_b; reg_pc++; break;									//	ld		d,b
		case 0x51: reg_d = reg_c; reg_pc++; break;									//	ld		d,c
		case 0x52: reg_d = reg_d; reg_pc++; break;									//	ld		d,d
		case 0x53: reg_d = reg_e; reg_pc++; break;									//	ld		d,e
		case 0x54: reg_d = reg_h; reg_pc++; break;									//	ld		d,h
		case 0x55: reg_d = reg_l; reg_pc++; break;									//	ld		d,l
		case 0x56: reg_d = readmemb(reg_hl); reg_pc++; break;						//	ld		d,(hl)
		case 0x57: reg_d = reg_a; reg_pc++; break;									//	ld		d,a
		case 0x58: reg_e = reg_b; reg_pc++; break;									//	ld		e,b
		case 0x59: reg_e = reg_c; reg_pc++; break;									//	ld		e,c
		case 0x5a: reg_e = reg_d; reg_pc++; break;									//	ld		e,d
		case 0x5b: reg_e = reg_e; reg_pc++; break;									//	ld		e,e
		case 0x5c: reg_e = reg_h; reg_pc++; break;									//	ld		e,h
		case 0x5d: reg_e = reg_l; reg_pc++; break;									//	ld		e,l
		case 0x5e: reg_e = readmemb(reg_hl); reg_pc++; break;						//	ld		e,(hl)
		case 0x5f: reg_e = reg_a; reg_pc++; break;									//	ld		e,a
		case 0x60: reg_h = reg_b; reg_pc++; break;									//	ld		h,b
		case 0x61: reg_h = reg_c; reg_pc++; break;									//	ld		h,c
		case 0x62: reg_h = reg_d; reg_pc++; break;									//	ld		h,d
		case 0x63: reg_h = reg_e; reg_pc++; break;									//	ld		h,e
		case 0x64: reg_h = reg_h; reg_pc++; break;									//	ld		h,h
		case 0x65: reg_h = reg_l; reg_pc++; break;									//	ld		h,l
		case 0x66: reg_h = readmemb(reg_hl); reg_pc++; break;						//	ld		h,(hl)
		case 0x67: reg_h = reg_a; reg_pc++; break;									//	ld		h,a
		case 0x68: reg_l = reg_b; reg_pc++; break;									//	ld		l,b
		case 0x69: reg_l = reg_c; reg_pc++; break;									//	ld		l,c
		case 0x6a: reg_l = reg_d; reg_pc++; break;									//	ld		l,d
		case 0x6b: reg_l = reg_e; reg_pc++; break;									//	ld		l,e
		case 0x6c: reg_l = reg_h; reg_pc++; break;									//	ld		l,h
		case 0x6d: reg_l = reg_l; reg_pc++; break;									//	ld		l,l
		case 0x6e: reg_l = readmemb(reg_hl); reg_pc++; break;						//	ld		l,(hl)
		case 0x6f: reg_l = reg_a; reg_pc++; break;									//	ld		l,a
		case 0x70: writememb(reg_hl, reg_b); reg_pc++; break;						//	ld		(hl),b
		case 0x71: writememb(reg_hl, reg_c); reg_pc++; break;						//	ld		(hl),c
		case 0x72: writememb(reg_hl, reg_d); reg_pc++; break;						//	ld		(hl),d
		case 0x73: writememb(reg_hl, reg_e); reg_pc++; break;						//	ld		(hl),e
		case 0x74: writememb(reg_hl, reg_h); reg_pc++; break;						//	ld		(hl),h
		case 0x75: writememb(reg_hl, reg_l); reg_pc++; break;						//	ld		(hl),l
		case 0x76: printf("Normal end\n"); return;									//	halt
		case 0x77: writememb(reg_hl, reg_a); reg_pc++; break;						//	ld		(hl),a
		case 0x78: reg_a = reg_b; reg_pc++; break;									//	ld		a,b
		case 0x79: reg_a = reg_c; reg_pc++; break;									//	ld		a,c
		case 0x7a: reg_a = reg_d; reg_pc++; break;									//	ld		a,d
		case 0x7b: reg_a = reg_e; reg_pc++; break;									//	ld		a,e
		case 0x7c: reg_a = reg_h; reg_pc++; break;									//	ld		a,h
		case 0x7d: reg_a = reg_l; reg_pc++; break;									//	ld		a,l
		case 0x7e: reg_a = readmemb(reg_hl); reg_pc++; break;						//	ld		a,(hl)
		case 0x7f: reg_a = reg_a; reg_pc++; break;									//	ld		a,a

		case 0x80: addregb(reg_b); reg_pc++; break;									//	add		a,b
		case 0x81: addregb(reg_c); reg_pc++; break;									//	add		a,c
		case 0x82: addregb(reg_d); reg_pc++; break;									//	add		a,d
		case 0x83: addregb(reg_e); reg_pc++; break;									//	add		a,e
		case 0x84: addregb(reg_h); reg_pc++; break;									//	add		a,h
		case 0x85: addregb(reg_l); reg_pc++; break;									//	add		a,l
		case 0x86: addregb(readmemb(reg_hl)); reg_pc++; break;						//	add		a,(hl)
		case 0x87: addregb(reg_a); reg_pc++; break;									//	add		a,a
		case 0x88: adcregb(reg_b); reg_pc++; break;									//	adc		a,b
		case 0x89: adcregb(reg_c); reg_pc++; break;									//	adc		a,c
		case 0x8a: adcregb(reg_d); reg_pc++; break;									//	adc		a,d
		case 0x8b: adcregb(reg_e); reg_pc++; break;									//	adc		a,e
		case 0x8c: adcregb(reg_h); reg_pc++; break;									//	adc		a,h
		case 0x8d: adcregb(reg_l); reg_pc++; break;									//	adc		a,l
		case 0x8e: adcregb(readmemb(reg_hl)); reg_pc++; break;						//	adc		a,(hl)
		case 0x8f: adcregb(reg_a); reg_pc++; break;									//	adc		a,a
		case 0x90: subregb(reg_b); reg_pc++; break;									//	sub		b
		case 0x91: subregb(reg_c); reg_pc++; break;									//	sub		c
		case 0x92: subregb(reg_d); reg_pc++; break;									//	sub		d
		case 0x93: subregb(reg_e); reg_pc++; break;									//	sub		e
		case 0x94: subregb(reg_h); reg_pc++; break;									//	sub		h
		case 0x95: subregb(reg_l); reg_pc++; break;									//	sub		l
		case 0x96: subregb(readmemb(reg_hl)); reg_pc++; break;						//	sub		(hl)
		case 0x97: subregb(reg_a); reg_pc++; break;									//	sub		a
		case 0x98: sbcregb(reg_b); reg_pc++; break;									//	sbc		a,b
		case 0x99: sbcregb(reg_c); reg_pc++; break;									//	sbc		a,c
		case 0x9a: sbcregb(reg_d); reg_pc++; break;									//	sbc		a,d
		case 0x9b: sbcregb(reg_e); reg_pc++; break;									//	sbc		a,e
		case 0x9c: sbcregb(reg_h); reg_pc++; break;									//	sbc		a,h
		case 0x9d: sbcregb(reg_l); reg_pc++; break;									//	sbc		a,l
		case 0x9e: sbcregb(readmemb(reg_hl)); reg_pc++; break;						//	sbc		a,(hl)
		case 0x9f: sbcregb(reg_a); reg_pc++; break;									//	sbc		a,a
		case 0xa0: andregb(reg_b); reg_pc++; break;									//	and		b
		case 0xa1: andregb(reg_c); reg_pc++; break;									//	and		c
		case 0xa2: andregb(reg_d); reg_pc++; break;									//	and		d
		case 0xa3: andregb(reg_e); reg_pc++; break;									//	and		e
		case 0xa4: andregb(reg_h); reg_pc++; break;									//	and		h
		case 0xa5: andregb(reg_l); reg_pc++; break;									//	and		l
		case 0xa6: andregb(readmemb(reg_hl)); reg_pc++; break;						//	and		(hl)
		case 0xa7: andregb(reg_a); reg_pc++; break;									//	and		a
		case 0xa8: xorregb(reg_b); reg_pc++; break;									//	xor		b
		case 0xa9: xorregb(reg_c); reg_pc++; break;									//	xor		c
		case 0xaa: xorregb(reg_d); reg_pc++; break;									//	xor		d
		case 0xab: xorregb(reg_e); reg_pc++; break;									//	xor		e
		case 0xac: xorregb(reg_h); reg_pc++; break;									//	xor		h
		case 0xad: xorregb(reg_l); reg_pc++; break;									//	xor		l
		case 0xae: xorregb(readmemb(reg_hl)); reg_pc++; break;						//	xor		(hl)
		case 0xaf: xorregb(reg_a); reg_pc++; break;									//	xor		a
		case 0xb0:  orregb(reg_b); reg_pc++; break;									//	or		b
		case 0xb1:  orregb(reg_c); reg_pc++; break;									//	or		c
		case 0xb2:  orregb(reg_d); reg_pc++; break;									//	or		d
		case 0xb3:  orregb(reg_e); reg_pc++; break;									//	or		e
		case 0xb4:  orregb(reg_h); reg_pc++; break;									//	or		h
		case 0xb5:  orregb(reg_l); reg_pc++; break;									//	or		l
		case 0xb6:  orregb(readmemb(reg_hl)); reg_pc++; break;						//	or		(hl)
		case 0xb7:  orregb(reg_a); reg_pc++; break;									//	or		a
		case 0xb8:  cpregb(reg_b); reg_pc++; break;									//	cp		b
		case 0xb9:  cpregb(reg_c); reg_pc++; break;									//	cp		c
		case 0xba:  cpregb(reg_d); reg_pc++; break;									//	cp		d
		case 0xbb:  cpregb(reg_e); reg_pc++; break;									//	cp		e
		case 0xbc:  cpregb(reg_h); reg_pc++; break;									//	cp		h
		case 0xbd:  cpregb(reg_l); reg_pc++; break;									//	cp		l
		case 0xbe:  cpregb(readmemb(reg_hl)); reg_pc++; break;						//	cp		(hl)
		case 0xbf:  cpregb(reg_a); reg_pc++; break;									//	cp		a

		case 0x00: reg_pc ++; break;												//	nop

		case 0x06: reg_b = readmemb(reg_pc+1); reg_pc+=2; break;					//	ld		b,n
		case 0x0e: reg_c = readmemb(reg_pc+1); reg_pc+=2; break;					//	ld		c,n
		case 0x16: reg_d = readmemb(reg_pc+1); reg_pc+=2; break;					//	ld		d,n
		case 0x1e: reg_e = readmemb(reg_pc+1); reg_pc+=2; break;					//	ld		e,n
		case 0x26: reg_h = readmemb(reg_pc+1); reg_pc+=2; break;					//	ld		h,n
		case 0x2e: reg_l = readmemb(reg_pc+1); reg_pc+=2; break;					//	ld		l,n
		case 0x36: writememb(reg_hl, readmemb(reg_pc+1)); reg_pc+=2; break;			//	ld		(hl),n
		case 0x3e: reg_a = readmemb(reg_pc+1); reg_pc+=2; break;					//	ld		a,n

		case 0xc6: addregb(readmemb(reg_pc+1)); reg_pc+=2; break;					//	add		a,n
		case 0xce: adcregb(readmemb(reg_pc+1)); reg_pc+=2; break;					//	adc		a,n
		case 0xd6: subregb(readmemb(reg_pc+1)); reg_pc+=2; break;					//	sub		n
		case 0xde: sbcregb(readmemb(reg_pc+1)); reg_pc+=2; break;					//	sbc		a,n
		case 0xe6: andregb(readmemb(reg_pc+1)); reg_pc+=2; break;					//	and		n
		case 0xee: xorregb(readmemb(reg_pc+1)); reg_pc+=2; break;					//	xor		n
		case 0xf6:  orregb(readmemb(reg_pc+1)); reg_pc+=2; break;					//	or		n
		case 0xfe:  cpregb(readmemb(reg_pc+1)); reg_pc+=2; break;					//	cp		n

		case 0x04: reg_b = incregb(reg_b); reg_pc++; break;							//	inc		b
		case 0x0c: reg_c = incregb(reg_c); reg_pc++; break;							//	inc		c
		case 0x14: reg_d = incregb(reg_d); reg_pc++; break;							//	inc		d
		case 0x1c: reg_e = incregb(reg_e); reg_pc++; break;							//	inc		e
		case 0x24: reg_h = incregb(reg_h); reg_pc++; break;							//	inc		h
		case 0x2c: reg_l = incregb(reg_l); reg_pc++; break;							//	inc		l
		case 0x34: writememb(reg_hl,incregb(readmemb(reg_hl))); reg_pc++; break;	//	inc		(hl)
		case 0x3c: reg_a = incregb(reg_a); reg_pc++; break;							//	inc		a
		case 0x05: reg_b = decregb(reg_b); reg_pc++; break;							//	dec		b
		case 0x0d: reg_c = decregb(reg_c); reg_pc++; break;							//	dec		c
		case 0x15: reg_d = decregb(reg_d); reg_pc++; break;							//	dec		d
		case 0x1d: reg_e = decregb(reg_e); reg_pc++; break;							//	dec		e
		case 0x25: reg_h = decregb(reg_h); reg_pc++; break;							//	dec		h
		case 0x2d: reg_l = decregb(reg_l); reg_pc++; break;							//	dec		l
		case 0x35: writememb(reg_hl,decregb(readmemb(reg_hl))); reg_pc++; break;	//	dec		(hl)
		case 0x3d: reg_a = decregb(reg_a); reg_pc++; break;							//	dec		a

		case 0x02: writememb(reg_bc, reg_a); reg_pc++; break;						//	ld		(bc),a
		case 0x12: writememb(reg_de, reg_a); reg_pc++; break;						//	ld		(de),a
		case 0x32: writememb(readmemw(reg_pc+1), reg_a); reg_pc+=3; break;			//	ld		(nn),a

		case 0x0a: reg_a = readmemb(reg_bc); reg_pc++; break;						//	ld		a,(bc)
		case 0x1a: reg_a = readmemb(reg_de); reg_pc++; break;						//	ld		a,(de)
		case 0x3a: reg_a = readmemb(readmemw(reg_pc+1)); reg_pc+=3; break;			//	ld		a,(nn)

		case 0x01: reg_bc = readmemw(reg_pc+1); reg_pc+=3; break;					//	ld		bc,nn
		case 0x11: reg_de = readmemw(reg_pc+1); reg_pc+=3; break;					//	ld		de,nn
		case 0x21: reg_hl = readmemw(reg_pc+1); reg_pc+=3; break;					//	ld		hl,nn
		case 0x31: reg_sp = readmemw(reg_pc+1); reg_pc+=3; break;					//	ld		sp,nn

		case 0x03: reg_bc = incregw(reg_bc); reg_pc++; break;						//	inc		bc
		case 0x13: reg_de = incregw(reg_de); reg_pc++; break;						//	inc		de
		case 0x23: reg_hl = incregw(reg_hl); reg_pc++; break;						//	inc		hl
		case 0x33: reg_sp = incregw(reg_sp); reg_pc++; break;						//	inc		sp
		case 0x0b: reg_bc = decregw(reg_bc); reg_pc++; break;						//	dec		bc
		case 0x1b: reg_de = decregw(reg_de); reg_pc++; break;						//	dec		de
		case 0x2b: reg_hl = decregw(reg_hl); reg_pc++; break;						//	dec		hl
		case 0x3b: reg_sp = decregw(reg_sp); reg_pc++; break;						//	dec		sp

		case 0x09: reg_hl = addregw(reg_hl, reg_bc); reg_pc++; break;				//	add		hl,bc
		case 0x19: reg_hl = addregw(reg_hl, reg_de); reg_pc++; break;				//	add		hl,de
		case 0x29: reg_hl = addregw(reg_hl, reg_hl); reg_pc++; break;				//	add		hl,hl
		case 0x39: reg_hl = addregw(reg_hl, reg_sp); reg_pc++; break;				//	add		hl,sp

		case 0x07: rlcaregb(); reg_pc++; break;										//	rlca
		case 0x0f: rrcaregb(); reg_pc++; break;										//	rrca
		case 0x17:  rlaregb(); reg_pc++; break;										//	rla
		case 0x1f:  rraregb(); reg_pc++; break;										//	rra
//		case 0x27: reg_pc++; break;													//	daa
		case 0x2f: reg_a ^= 0xff; reg_pc++; break;									//	cpl
		case 0x37: setcflag(); reg_pc++; break;										//	scf
		case 0x3f: reg_f ^= 0x01; reg_pc++; break;									//	ccf

		case 0x2a: reg_hl = readmemw(readmemw(reg_pc+1)); reg_pc+=3; break;			//	ld		hl,(nn)

		case 0x22: writememw(readmemw(reg_pc+1), reg_hl); reg_pc+=3; break;			//	ld		(nn),hl

		case 0xf9: reg_sp = reg_hl; reg_pc++; break;								//	ld		sp,hl

		case 0xeb: tmpw0 = reg_hl; reg_hl = reg_de; reg_de = tmpw0;
					reg_pc++; break;												//	ex		de,hl
		case 0x08: tmpw0 = reg_af; reg_af = reg_af_; reg_af_ = tmpw0;
					reg_pc++; break;												//	ex		af,af'
		case 0xd9:	tmpw0 = reg_bc; reg_bc = reg_bc_; reg_bc_ = tmpw0;
					tmpw0 = reg_de; reg_de = reg_de_; reg_de_ = tmpw0;
					tmpw0 = reg_hl; reg_hl = reg_hl_; reg_hl_ = tmpw0;
					reg_pc++; break;												//	exx
		case 0xe3: tmpw0 = reg_hl; reg_hl = readmemw(reg_sp); writememw(reg_sp, tmpw0);
					reg_pc++; break;												//	ex		(sp),hl

		case 0xf3: reg_pc++; break;													//	di
		case 0xfb: reg_pc++; break;													//	ei

		case 0xc1: reg_bc = readmemw(reg_sp); reg_sp+=2; reg_pc++; break;			//	pop		bc
		case 0xd1: reg_de = readmemw(reg_sp); reg_sp+=2; reg_pc++; break;			//	pop		de
		case 0xe1: reg_hl = readmemw(reg_sp); reg_sp+=2; reg_pc++; break;			//	pop		hl
		case 0xf1: reg_af = readmemw(reg_sp); reg_sp+=2; reg_pc++; break;			//	pop		af
		case 0xc5: reg_sp-=2; writememw(reg_sp, reg_bc); reg_pc++; break;			//	push	bc
		case 0xd5: reg_sp-=2; writememw(reg_sp, reg_de); reg_pc++; break;			//	push	de
		case 0xe5: reg_sp-=2; writememw(reg_sp, reg_hl); reg_pc++; break;			//	push	hl
		case 0xf5: reg_sp-=2; writememw(reg_sp, reg_af); reg_pc++; break;			//	push	af

		case 0xc3: reg_pc = readmemw(reg_pc+1); break;								//	jp		nn
		case 0xc2: reg_pc = (!is_zflag) ? readmemw(reg_pc+1) : reg_pc+3; break;		//	jp		nz,nn
		case 0xca: reg_pc = ( is_zflag) ? readmemw(reg_pc+1) : reg_pc+3; break;		//	jp		z,nn
		case 0xd2: reg_pc = (!is_cflag) ? readmemw(reg_pc+1) : reg_pc+3; break;		//	jp		nc,nn
		case 0xda: reg_pc = ( is_cflag) ? readmemw(reg_pc+1) : reg_pc+3; break;		//	jp		c,nn
//		case 0xe2: reg_pc+=3; break;												//	jp		po,nn
//		case 0xea: reg_pc+=3; break;												//	jp		pe,nn
//		case 0xf2: reg_pc+=3; break;												//	jp		p,nn
//		case 0xfa: reg_pc+=3; break;												//	jp		m,nn

		case 0x18: reg_pc = reladd(reg_pc+1); break;								//	jr		e
		case 0x20: reg_pc = (!is_zflag) ? reladd(reg_pc+1) : reg_pc+2; break;		//	jr		nz,e
		case 0x28: reg_pc = ( is_zflag) ? reladd(reg_pc+1) : reg_pc+2; break;		//	jr		z,e
		case 0x30: reg_pc = (!is_cflag) ? reladd(reg_pc+1) : reg_pc+2; break;		//	jr		nc,e
		case 0x38: reg_pc = ( is_cflag) ? reladd(reg_pc+1) : reg_pc+2; break;		//	jr		c,e
		case 0x10: reg_b--;
					reg_pc =    (reg_b) ? reladd(reg_pc+1) : reg_pc+2; break;		//	djnz	e

		case 0xe9: reg_pc = reg_hl; break;											//	jp		(hl)

		case 0xcd: reg_pc+=3;reg_sp-=2; writememw(reg_sp, reg_pc);
					reg_pc = readmemw(reg_pc-2); break;								//	call	nn
		case 0xc4: reg_pc+=3;														//	call	nz,nn
					if (!is_zflag) {
						reg_sp-=2; writememw(reg_sp, reg_pc); reg_pc = readmemw(reg_pc-2);
					}
					break;
		case 0xcc: reg_pc+=3;														//	call	z,nn
					if ( is_zflag) {
						reg_sp-=2; writememw(reg_sp, reg_pc); reg_pc = readmemw(reg_pc-2);
					}
					break;
		case 0xd4: reg_pc+=3;														//	call	nc,nn
					if (!is_cflag) {
						reg_sp-=2; writememw(reg_sp, reg_pc); reg_pc = readmemw(reg_pc-2);
					}
					break;
		case 0xdc: reg_pc+=3;														//	call	c,nn
					if ( is_cflag) {
						reg_sp-=2; writememw(reg_sp, reg_pc); reg_pc = readmemw(reg_pc-2);
					}
					break;
//		case 0xe4: reg_pc+=3; break;												//	call	po,nn
//		case 0xec: reg_pc+=3; break;												//	call	pe,nn
//		case 0xf4: reg_pc+=3; break;												//	call	p,nn
//		case 0xfc: reg_pc+=3; break;												//	call	m,nn

		case 0xc9: reg_pc = readmemw(reg_sp); reg_sp+=2; break;						//	ret
		case 0xc0: if (!is_zflag) {													//	ret		nz
						reg_pc = readmemw(reg_sp); reg_sp+=2;
					} else {
						reg_pc++;
					}
					break;
		case 0xc8: if ( is_zflag) {													//	ret		z
						reg_pc = readmemw(reg_sp); reg_sp+=2;
					} else {
						reg_pc++;
					}
					break;
		case 0xd0: if (!is_cflag) {													//	ret		nc
						reg_pc = readmemw(reg_sp); reg_sp+=2;
					} else {
						reg_pc++;
					}
					break;
		case 0xd8: if ( is_cflag) {													//	ret		c
						reg_pc = readmemw(reg_sp); reg_sp+=2;
					} else {
						reg_pc++;
					}
					break;
//		case 0xe0: reg_pc++; break;													//	ret		po
//		case 0xe8: reg_pc++; break;													//	ret		pe
//		case 0xf0: reg_pc++; break;													//	ret		p
//		case 0xf8: reg_pc++; break;													//	ret		m

		case 0xd3: portout(readmemb(reg_pc+1), reg_a); reg_pc+=2; break;			//	out		(n),a
//		case 0xdb: reg_pc+=2; break;												//	in		a,(n)

		case 0xc7: reg_a = (fgetc(infp) & 0x000000ff); reg_pc++; break;				//	rst		0x00

//		case 0xcf: reg_pc++; break;													//	rst		0x08
//		case 0xd7: reg_pc++; break;													//	rst		0x10
//		case 0xdf: reg_pc++; break;													//	rst		0x18
//		case 0xe7: reg_pc++; break;													//	rst		0x20
//		case 0xef: reg_pc++; break;													//	rst		0x28

		case 0xf7:																	//	rst		0x30
			printf("main memory\n");
			for (i = 0;i < 0x10000;i += 16) {
				printf("%04X:",i);
				for (j = 0;j < 16;j ++) {
					printf("%02X ",mainmem[i+j]);
				}
				printf("\n");
			}
			reg_pc++; break;

		case 0xff:																	//	rst		0x38
			printf("register\n");
			printf(" AF :%04X   BC :%04X   DE :%04X   HL :%04X\n",reg_af, reg_bc, reg_de, reg_hl);
			printf(" AF':%04X   BC':%04X   DE':%04X   HL':%04X\n",reg_af_,reg_bc_,reg_de_,reg_hl_);
			printf(" IX :%04X   IY :%04X   PC :%04X   SP :%04X\n",reg_ix, reg_iy, reg_pc, reg_sp);
			printf("(HL):%04X  (BC):%04X  (DE):%04X  (SP):%04X\n",
				readmemw(reg_hl), readmemw(reg_bc), readmemw(reg_de), readmemw(reg_sp) );
			reg_pc++; break;

		case 0xdd:
		case 0xfd:
			reg_ixy = (m0 == 0xdd) ? reg_ix : reg_iy;
			reg_pc++;
			switch (m1) {
			case 0x46: reg_b = readmemixb(m0, reg_pc+1); reg_pc+=2; break;			//	ld		b,(ix+d)
			case 0x4e: reg_c = readmemixb(m0, reg_pc+1); reg_pc+=2; break;			//	ld		c,(ix+d)
			case 0x56: reg_d = readmemixb(m0, reg_pc+1); reg_pc+=2; break;			//	ld		d,(ix+d)
			case 0x5e: reg_e = readmemixb(m0, reg_pc+1); reg_pc+=2; break;			//	ld		e,(ix+d)
			case 0x66: reg_h = readmemixb(m0, reg_pc+1); reg_pc+=2; break;			//	ld		h,(ix+d)
			case 0x6e: reg_l = readmemixb(m0, reg_pc+1); reg_pc+=2; break;			//	ld		l,(ix+d)
			case 0x70: writememixb(m0, reg_pc+1, reg_b); reg_pc+=2; break;			//	ld		(ix+d),b
			case 0x71: writememixb(m0, reg_pc+1, reg_c); reg_pc+=2; break;			//	ld		(ix+d),c
			case 0x72: writememixb(m0, reg_pc+1, reg_d); reg_pc+=2; break;			//	ld		(ix+d),d
			case 0x73: writememixb(m0, reg_pc+1, reg_e); reg_pc+=2; break;			//	ld		(ix+d),e
			case 0x74: writememixb(m0, reg_pc+1, reg_h); reg_pc+=2; break;			//	ld		(ix+d),h
			case 0x75: writememixb(m0, reg_pc+1, reg_l); reg_pc+=2; break;			//	ld		(ix+d),l
			case 0x77: writememixb(m0, reg_pc+1, reg_a); reg_pc+=2; break;			//	ld		(ix+d),a
			case 0x7e: reg_a = readmemixb(m0, reg_pc+1); reg_pc+=2; break;			//	ld		a,(ix+d)

			case 0x36: writememixb(m0, reg_pc+1, readmemb(reg_pc+2)); reg_pc+=3; break;//ld		(ix+d),n
			case 0x21: setixy(m0, readmemw(reg_pc+1) ); reg_pc+=3; break;			//	ld		ix,nn
			case 0x2a: setixy(m0, readmemw(readmemw(reg_pc+1)) ); reg_pc+=3; break;	//	ld		ix,(nn)
			case 0x22: writememw(readmemw(reg_pc+1), reg_ixy); reg_pc+=3; break;	//	ld		(nn),ix
			case 0xf9: reg_sp = reg_ixy; reg_pc++; break;							//	ld		sp,ix

			case 0xe3: setixy(m0, readmemw(reg_sp)); writememw(reg_sp, reg_ixy);
					reg_pc++; break;												//	ex		(sp),ix

			case 0x09: setixy(m0, addregw(reg_ixy, reg_bc )); reg_pc++; break;		//	add		ix,bc
			case 0x19: setixy(m0, addregw(reg_ixy, reg_de )); reg_pc++; break;		//	add		ix,de
			case 0x29: setixy(m0, addregw(reg_ixy, reg_ixy)); reg_pc++; break;		//	add		ix,ix
			case 0x39: setixy(m0, addregw(reg_ixy, reg_sp )); reg_pc++; break;		//	add		ix,sp

			case 0x23: setixy(m0, incregw(reg_ixy)); reg_pc++; break;				//	inc		ix
			case 0x2b: setixy(m0, decregw(reg_ixy)); reg_pc++; break;				//	dec		ix

			case 0x34: tmpb0 = readmemixb(m0, reg_pc+1);
						writememixb(m0, reg_pc+1, incregb(tmpb0));
						reg_pc+=2; break;											//	inc		(ix+d)
			case 0x35: tmpb0 = readmemixb(m0, reg_pc+1);
						writememixb(m0, reg_pc+1, decregb(tmpb0));
						reg_pc+=2; break;											//	dec		(ix+d)

			case 0x86: addregb(readmemixb(m0, reg_pc+1)); reg_pc+=2; break;			//	add		a,(ix+d)
			case 0x8e: adcregb(readmemixb(m0, reg_pc+1)); reg_pc+=2; break;			//	adc		a,(ix+d)
			case 0x96: subregb(readmemixb(m0, reg_pc+1)); reg_pc+=2; break;			//	sub		(ix+d)
			case 0x9e: sbcregb(readmemixb(m0, reg_pc+1)); reg_pc+=2; break;			//	sbc		a,(ix+d)
			case 0xa6: andregb(readmemixb(m0, reg_pc+1)); reg_pc+=2; break;			//	and		(ix+d)
			case 0xae: xorregb(readmemixb(m0, reg_pc+1)); reg_pc+=2; break;			//	xor		(ix+d)
			case 0xb6:  orregb(readmemixb(m0, reg_pc+1)); reg_pc+=2; break;			//	or		(ix+d)
			case 0xbe:  cpregb(readmemixb(m0, reg_pc+1)); reg_pc+=2; break;			//	cp		(ix+d)

			case 0xe1: setixy(m0, readmemw(reg_sp)); reg_sp+=2; reg_pc++; break;	//	pop		ix
			case 0xe5: reg_sp-=2; writememw(reg_sp, reg_ixy); reg_pc++; break;		//	push	ix

			case 0xe9: reg_pc = reg_ixy; break;										//	jp		(ix)

//			case 0xcb:

			default: printf("Illigal command PC:%04X DT:%02X %02X\n",reg_pc, m0, m1); reg_pc++; break;
			}
			break;

		case 0xed:
			reg_pc++;
			switch (m1) {
			case 0x4b: reg_bc = readmemw(readmemw(reg_pc+1)); reg_pc+=3; break;		//	ld		bc,(nn)
			case 0x5b: reg_de = readmemw(readmemw(reg_pc+1)); reg_pc+=3; break;		//	ld		de,(nn)
			case 0x6b: reg_hl = readmemw(readmemw(reg_pc+1)); reg_pc+=3; break;		//	ld		hl,(nn)
			case 0x7b: reg_sp = readmemw(readmemw(reg_pc+1)); reg_pc+=3; break;		//	ld		sp,(nn)

			case 0x43: writememw(readmemw(reg_pc+1), reg_bc); reg_pc+=3; break;		//	ld		(nn),bc
			case 0x53: writememw(readmemw(reg_pc+1), reg_de); reg_pc+=3; break;		//	ld		(nn),de
			case 0x63: writememw(readmemw(reg_pc+1), reg_hl); reg_pc+=3; break;		//	ld		(nn),hl
			case 0x73: writememw(readmemw(reg_pc+1), reg_sp); reg_pc+=3; break;		//	ld		(nn),sp

			case 0x4a: reg_hl = adcregw(reg_hl, reg_bc); reg_pc++; break;			//	adc		hl,bc
			case 0x5a: reg_hl = adcregw(reg_hl, reg_de); reg_pc++; break;			//	adc		hl,de
			case 0x6a: reg_hl = adcregw(reg_hl, reg_hl); reg_pc++; break;			//	adc		hl,hl
			case 0x7a: reg_hl = adcregw(reg_hl, reg_sp); reg_pc++; break;			//	adc		hl,sp

			case 0x42: reg_hl = sbcregw(reg_hl, reg_bc); reg_pc++; break;			//	sbc		hl,bc
			case 0x52: reg_hl = sbcregw(reg_hl, reg_de); reg_pc++; break;			//	sbc		hl,de
			case 0x62: reg_hl = sbcregw(reg_hl, reg_hl); reg_pc++; break;			//	sbc		hl,hl
			case 0x72: reg_hl = sbcregw(reg_hl, reg_sp); reg_pc++; break;			//	sbc		hl,sp

			case 0xa0: writememb(reg_de, readmemb(reg_hl) );
						reg_de++; reg_hl++; reg_bc--; reg_pc++; break;				//	ldi
			case 0xa8: writememb(reg_de, readmemb(reg_hl) );
						reg_de--; reg_hl--; reg_bc--; reg_pc++; break;				//	ldd
			case 0xb0: writememb(reg_de, readmemb(reg_hl) );
						reg_de++; reg_hl++; reg_bc--;
						reg_pc = (reg_bc) ? reg_pc-1 : reg_pc+1; break;				//	ldir
			case 0xb8: writememb(reg_de, readmemb(reg_hl) );
						reg_de--; reg_hl--; reg_bc--;
						reg_pc = (reg_bc) ? reg_pc-1 : reg_pc+1; break;				//	lddr

			case 0x41: portout(reg_c, reg_b); reg_pc++; break;						//	out		(c),b
			case 0x49: portout(reg_c, reg_c); reg_pc++; break;						//	out		(c),c
			case 0x51: portout(reg_c, reg_d); reg_pc++; break;						//	out		(c),d
			case 0x59: portout(reg_c, reg_e); reg_pc++; break;						//	out		(c),e
			case 0x61: portout(reg_c, reg_h); reg_pc++; break;						//	out		(c),h
			case 0x69: portout(reg_c, reg_l); reg_pc++; break;						//	out		(c),l
			case 0x79: portout(reg_c, reg_a); reg_pc++; break;						//	out		(c),a

			case 0x67:	tmpb0 = readmemb(reg_hl);
						writememb(reg_hl, ((reg_a & 0x0f)<<4) | ((tmpb0 & 0xf0)>>4) );
						reg_a = ( (reg_a & 0xf0) | (tmpb0 & 0x0f) );
						reg_pc++; break;											//	rrd

			case 0x6f:	tmpb0 = readmemb(reg_hl);
						writememb(reg_hl, ((tmpb0 & 0x0f)<<4) | (reg_a & 0x0f) );
						reg_a = ( (reg_a & 0xf0) | ((tmpb0 & 0xf0)>>4) );
						reg_pc++; break;											//	rld

//			case 0x40: reg_pc++; break;												//	in		b,(c)
//			case 0x48: reg_pc++; break;												//	in		c,(c)
//			case 0x50: reg_pc++; break;												//	in		d,(c)
//			case 0x58: reg_pc++; break;												//	in		e,(c)
//			case 0x60: reg_pc++; break;												//	in		h,(c)
//			case 0x68: reg_pc++; break;												//	in		l,(c)
//			case 0x70: reg_pc++; break;												//	in		f,(c)
//			case 0x78: reg_pc++; break;												//	in		a,(c)

//			case 0x44: reg_pc++; break;												//	neg
//			case 0x45: reg_pc++; break;												//	retn
//			case 0x4d: reg_pc++; break;												//	reti
//			case 0x46: reg_pc++; break;												//	im		0
//			case 0x5e: reg_pc++; break;												//	im		2
//			case 0x56: reg_pc++; break;												//	im		1
//			case 0x47: reg_pc++; break;												//	ld		i,a
//			case 0x4f: reg_pc++; break;												//	ld		r,a
//			case 0x57: reg_pc++; break;												//	ld		a,i
//			case 0x5f: reg_pc++; break;												//	ld		a,r
	
//			case 0xa1: reg_pc++; break;												//	cpi
//			case 0xa2: reg_pc++; break;												//	ini
//			case 0xa3: reg_pc++; break;												//	outi
//			case 0xa9: reg_pc++; break;												//	cpd
//			case 0xaa: reg_pc++; break;												//	ind
//			case 0xab: reg_pc++; break;												//	outd
//			case 0xb1: reg_pc++; break;												//	cpir
//			case 0xb2: reg_pc++; break;												//	inir
//			case 0xb3: reg_pc++; break;												//	otir
//			case 0xb9: reg_pc++; break;												//	cpdr
//			case 0xba: reg_pc++; break;												//	indr
//			case 0xbb: reg_pc++; break;												//	otdr

			default: printf("Illigal command PC:%04X DT:%02X %02X\n",reg_pc, m0, m1); reg_pc++; break;
			}
			break;


		case 0xcb:
			reg_pc++;
			switch (m1) {
			case 0x00: reg_b = rlcregb(reg_b); reg_pc++; break;						//	rlc		b
			case 0x01: reg_c = rlcregb(reg_c); reg_pc++; break;						//	rlc		c
			case 0x02: reg_d = rlcregb(reg_d); reg_pc++; break;						//	rlc		d
			case 0x03: reg_e = rlcregb(reg_e); reg_pc++; break;						//	rlc		e
			case 0x04: reg_h = rlcregb(reg_h); reg_pc++; break;						//	rlc		h
			case 0x05: reg_l = rlcregb(reg_l); reg_pc++; break;						//	rlc		l
			case 0x06: writememb(reg_hl, rlcregb(readmemb(reg_hl))); reg_pc++; break;//	rlc		(hl)
			case 0x07: reg_a = rrcregb(reg_a); reg_pc++; break;						//	rlc		a
			case 0x08: reg_b = rrcregb(reg_b); reg_pc++; break;						//	rrc		b
			case 0x09: reg_c = rrcregb(reg_c); reg_pc++; break;						//	rrc		c
			case 0x0a: reg_d = rrcregb(reg_d); reg_pc++; break;						//	rrc		d
			case 0x0b: reg_e = rrcregb(reg_e); reg_pc++; break;						//	rrc		e
			case 0x0c: reg_h = rrcregb(reg_h); reg_pc++; break;						//	rrc		h
			case 0x0d: reg_l = rrcregb(reg_l); reg_pc++; break;						//	rrc		l
			case 0x0e: writememb(reg_hl, rrcregb(readmemb(reg_hl))); reg_pc++; break;//	rrc		(hl)
			case 0x0f: reg_a = rrcregb(reg_a); reg_pc++; break;						//	rrc		a
			case 0x10: reg_b = rlregb(reg_b); reg_pc++; break;						//	rl		b
			case 0x11: reg_c = rlregb(reg_c); reg_pc++; break;						//	rl		c
			case 0x12: reg_d = rlregb(reg_d); reg_pc++; break;						//	rl		d
			case 0x13: reg_e = rlregb(reg_e); reg_pc++; break;						//	rl		e
			case 0x14: reg_h = rlregb(reg_h); reg_pc++; break;						//	rl		h
			case 0x15: reg_l = rlregb(reg_l); reg_pc++; break;						//	rl		l
			case 0x16: writememb(reg_hl, rlregb(readmemb(reg_hl))); reg_pc++; break;//	rl		(hl)
			case 0x17: reg_a = rlregb(reg_a); reg_pc++; break;						//	rl		a
			case 0x18: reg_b = rrregb(reg_b); reg_pc++; break;						//	rr		b
			case 0x19: reg_c = rrregb(reg_c); reg_pc++; break;						//	rr		c
			case 0x1a: reg_d = rrregb(reg_d); reg_pc++; break;						//	rr		d
			case 0x1b: reg_e = rrregb(reg_e); reg_pc++; break;						//	rr		e
			case 0x1c: reg_h = rrregb(reg_h); reg_pc++; break;						//	rr		h
			case 0x1d: reg_l = rrregb(reg_l); reg_pc++; break;						//	rr		l
			case 0x1e: writememb(reg_hl, rrregb(readmemb(reg_hl))); reg_pc++; break;//	rr		(hl)
			case 0x1f: reg_a = rrregb(reg_a); reg_pc++; break;						//	rr		a
			case 0x20: reg_b = slaregb(reg_b); reg_pc++; break;						//	sla		b
			case 0x21: reg_c = slaregb(reg_c); reg_pc++; break;						//	sla		c
			case 0x22: reg_d = slaregb(reg_d); reg_pc++; break;						//	sla		d
			case 0x23: reg_e = slaregb(reg_e); reg_pc++; break;						//	sla		e
			case 0x24: reg_h = slaregb(reg_h); reg_pc++; break;						//	sla		h
			case 0x25: reg_l = slaregb(reg_l); reg_pc++; break;						//	sla		l
			case 0x26: writememb(reg_hl, slaregb(readmemb(reg_hl))); reg_pc++; break;//	sla		(hl)
			case 0x27: reg_a = slaregb(reg_a); reg_pc++; break;						//	sla		a
			case 0x28: reg_b = sraregb(reg_b); reg_pc++; break;						//	sra		b
			case 0x29: reg_c = sraregb(reg_c); reg_pc++; break;						//	sra		c
			case 0x2a: reg_d = sraregb(reg_d); reg_pc++; break;						//	sra		d
			case 0x2b: reg_e = sraregb(reg_e); reg_pc++; break;						//	sra		e
			case 0x2c: reg_h = sraregb(reg_h); reg_pc++; break;						//	sra		h
			case 0x2d: reg_l = sraregb(reg_l); reg_pc++; break;						//	sra		l
			case 0x2e: writememb(reg_hl, sraregb(readmemb(reg_hl))); reg_pc++; break;//	sra		(hl)
			case 0x2f: reg_a = sraregb(reg_a); reg_pc++; break;						//	sra		a
			case 0x38: reg_b = srlregb(reg_b); reg_pc++; break;						//	srl		b
			case 0x39: reg_c = srlregb(reg_c); reg_pc++; break;						//	srl		c
			case 0x3a: reg_d = srlregb(reg_d); reg_pc++; break;						//	srl		d
			case 0x3b: reg_e = srlregb(reg_e); reg_pc++; break;						//	srl		e
			case 0x3c: reg_h = srlregb(reg_h); reg_pc++; break;						//	srl		h
			case 0x3d: reg_l = srlregb(reg_l); reg_pc++; break;						//	srl		l
			case 0x3e: writememb(reg_hl, srlregb(readmemb(reg_hl))); reg_pc++; break;//	srl		(hl)
			case 0x3f: reg_a = srlregb(reg_a); reg_pc++; break;						//	srl		a

			case 0x40: bitregb(0, reg_b); reg_pc++; break;							//	bit		0,b
			case 0x41: bitregb(0, reg_c); reg_pc++; break;							//	bit		0,c
			case 0x42: bitregb(0, reg_d); reg_pc++; break;							//	bit		0,d
			case 0x43: bitregb(0, reg_e); reg_pc++; break;							//	bit		0,e
			case 0x44: bitregb(0, reg_h); reg_pc++; break;							//	bit		0,h
			case 0x45: bitregb(0, reg_l); reg_pc++; break;							//	bit		0,l
			case 0x46: bitregb(0, readmemb(reg_hl)); reg_pc++; break;				//	bit		0,(hl)
			case 0x47: bitregb(0, reg_a); reg_pc++; break;							//	bit		0,a
			case 0x48: bitregb(1, reg_b); reg_pc++; break;							//	bit		1,b
			case 0x49: bitregb(1, reg_c); reg_pc++; break;							//	bit		1,c
			case 0x4a: bitregb(1, reg_d); reg_pc++; break;							//	bit		1,d
			case 0x4b: bitregb(1, reg_e); reg_pc++; break;							//	bit		1,e
			case 0x4c: bitregb(1, reg_h); reg_pc++; break;							//	bit		1,h
			case 0x4d: bitregb(1, reg_l); reg_pc++; break;							//	bit		1,l
			case 0x4e: bitregb(1, readmemb(reg_hl)); reg_pc++; break;				//	bit		1,(hl)
			case 0x4f: bitregb(1, reg_a); reg_pc++; break;							//	bit		1,a
			case 0x50: bitregb(2, reg_b); reg_pc++; break;							//	bit		2,b
			case 0x51: bitregb(2, reg_c); reg_pc++; break;							//	bit		2,c
			case 0x52: bitregb(2, reg_d); reg_pc++; break;							//	bit		2,d
			case 0x53: bitregb(2, reg_e); reg_pc++; break;							//	bit		2,e
			case 0x54: bitregb(2, reg_h); reg_pc++; break;							//	bit		2,h
			case 0x55: bitregb(2, reg_l); reg_pc++; break;							//	bit		2,l
			case 0x56: bitregb(2, readmemb(reg_hl)); reg_pc++; break;				//	bit		2,(hl)
			case 0x57: bitregb(2, reg_a); reg_pc++; break;							//	bit		2,a
			case 0x58: bitregb(3, reg_b); reg_pc++; break;							//	bit		3,b
			case 0x59: bitregb(3, reg_c); reg_pc++; break;							//	bit		3,c
			case 0x5a: bitregb(3, reg_d); reg_pc++; break;							//	bit		3,d
			case 0x5b: bitregb(3, reg_e); reg_pc++; break;							//	bit		3,e
			case 0x5c: bitregb(3, reg_h); reg_pc++; break;							//	bit		3,h
			case 0x5d: bitregb(3, reg_l); reg_pc++; break;							//	bit		3,l
			case 0x5e: bitregb(3, readmemb(reg_hl)); reg_pc++; break;				//	bit		3,(hl)
			case 0x5f: bitregb(3, reg_a); reg_pc++; break;							//	bit		3,a
			case 0x60: bitregb(4, reg_b); reg_pc++; break;							//	bit		4,b
			case 0x61: bitregb(4, reg_c); reg_pc++; break;							//	bit		4,c
			case 0x62: bitregb(4, reg_d); reg_pc++; break;							//	bit		4,d
			case 0x63: bitregb(4, reg_e); reg_pc++; break;							//	bit		4,e
			case 0x64: bitregb(4, reg_h); reg_pc++; break;							//	bit		4,h
			case 0x65: bitregb(4, reg_l); reg_pc++; break;							//	bit		4,l
			case 0x66: bitregb(4, readmemb(reg_hl)); reg_pc++; break;				//	bit		4,(hl)
			case 0x67: bitregb(4, reg_a); reg_pc++; break;							//	bit		4,a
			case 0x68: bitregb(5, reg_b); reg_pc++; break;							//	bit		5,b
			case 0x69: bitregb(5, reg_c); reg_pc++; break;							//	bit		5,c
			case 0x6a: bitregb(5, reg_d); reg_pc++; break;							//	bit		5,d
			case 0x6b: bitregb(5, reg_e); reg_pc++; break;							//	bit		5,e
			case 0x6c: bitregb(5, reg_h); reg_pc++; break;							//	bit		5,h
			case 0x6d: bitregb(5, reg_l); reg_pc++; break;							//	bit		5,l
			case 0x6e: bitregb(5, readmemb(reg_hl)); reg_pc++; break;				//	bit		5,(hl)
			case 0x6f: bitregb(5, reg_a); reg_pc++; break;							//	bit		5,a
			case 0x70: bitregb(6, reg_b); reg_pc++; break;							//	bit		6,b
			case 0x71: bitregb(6, reg_c); reg_pc++; break;							//	bit		6,c
			case 0x72: bitregb(6, reg_d); reg_pc++; break;							//	bit		6,d
			case 0x73: bitregb(6, reg_e); reg_pc++; break;							//	bit		6,e
			case 0x74: bitregb(6, reg_h); reg_pc++; break;							//	bit		6,h
			case 0x75: bitregb(6, reg_l); reg_pc++; break;							//	bit		6,l
			case 0x76: bitregb(6, readmemb(reg_hl)); reg_pc++; break;				//	bit		6,(hl)
			case 0x77: bitregb(6, reg_a); reg_pc++; break;							//	bit		6,a
			case 0x78: bitregb(7, reg_b); reg_pc++; break;							//	bit		7,b
			case 0x79: bitregb(7, reg_c); reg_pc++; break;							//	bit		7,c
			case 0x7a: bitregb(7, reg_d); reg_pc++; break;							//	bit		7,d
			case 0x7b: bitregb(7, reg_e); reg_pc++; break;							//	bit		7,e
			case 0x7c: bitregb(7, reg_h); reg_pc++; break;							//	bit		7,h
			case 0x7d: bitregb(7, reg_l); reg_pc++; break;							//	bit		7,l
			case 0x7e: bitregb(7, readmemb(reg_hl)); reg_pc++; break;				//	bit		7,(hl)
			case 0x7f: bitregb(7, reg_a); reg_pc++; break;							//	bit		7,a

			case 0x80: reg_b = resregb(0, reg_b); reg_pc++; break;					//	res		0,b
			case 0x81: reg_c = resregb(0, reg_c); reg_pc++; break;					//	res		0,c
			case 0x82: reg_d = resregb(0, reg_d); reg_pc++; break;					//	res		0,d
			case 0x83: reg_e = resregb(0, reg_e); reg_pc++; break;					//	res		0,e
			case 0x84: reg_h = resregb(0, reg_h); reg_pc++; break;					//	res		0,h
			case 0x85: reg_l = resregb(0, reg_l); reg_pc++; break;					//	res		0,l
			case 0x86: writememb(reg_hl, resregb(0, readmemb(reg_hl)));reg_pc++;break;//res		0,(hl)
			case 0x87: reg_a = resregb(0, reg_a); reg_pc++; break;					//	res		0,a
			case 0x88: reg_b = resregb(1, reg_b); reg_pc++; break;					//	res		1,b
			case 0x89: reg_c = resregb(1, reg_c); reg_pc++; break;					//	res		1,c
			case 0x8a: reg_d = resregb(1, reg_d); reg_pc++; break;					//	res		1,d
			case 0x8b: reg_e = resregb(1, reg_e); reg_pc++; break;					//	res		1,e
			case 0x8c: reg_h = resregb(1, reg_h); reg_pc++; break;					//	res		1,h
			case 0x8d: reg_l = resregb(1, reg_l); reg_pc++; break;					//	res		1,l
			case 0x8e: writememb(reg_hl, resregb(1, readmemb(reg_hl)));reg_pc++;break;//res		1,(hl)
			case 0x8f: reg_a = resregb(1, reg_a); reg_pc++; break;					//	res		1,a
			case 0x90: reg_b = resregb(2, reg_b); reg_pc++; break;					//	res		2,b
			case 0x91: reg_c = resregb(2, reg_c); reg_pc++; break;					//	res		2,c
			case 0x92: reg_d = resregb(2, reg_d); reg_pc++; break;					//	res		2,d
			case 0x93: reg_e = resregb(2, reg_e); reg_pc++; break;					//	res		2,e
			case 0x94: reg_h = resregb(2, reg_h); reg_pc++; break;					//	res		2,h
			case 0x95: reg_l = resregb(2, reg_l); reg_pc++; break;					//	res		2,l
			case 0x96: writememb(reg_hl, resregb(2, readmemb(reg_hl)));reg_pc++;break;//res		2,(hl)
			case 0x97: reg_a = resregb(2, reg_a); reg_pc++; break;					//	res		2,a
			case 0x98: reg_b = resregb(3, reg_b); reg_pc++; break;					//	res		3,b
			case 0x99: reg_c = resregb(3, reg_c); reg_pc++; break;					//	res		3,c
			case 0x9a: reg_d = resregb(3, reg_d); reg_pc++; break;					//	res		3,d
			case 0x9b: reg_e = resregb(3, reg_e); reg_pc++; break;					//	res		3,e
			case 0x9c: reg_h = resregb(3, reg_h); reg_pc++; break;					//	res		3,h
			case 0x9d: reg_l = resregb(3, reg_l); reg_pc++; break;					//	res		3,l
			case 0x9e: writememb(reg_hl, resregb(3, readmemb(reg_hl)));reg_pc++;break;//res		3,(hl)
			case 0x9f: reg_a = resregb(3, reg_a); reg_pc++; break;					//	res		3,a
			case 0xa0: reg_b = resregb(4, reg_b); reg_pc++; break;					//	res		4,b
			case 0xa1: reg_c = resregb(4, reg_c); reg_pc++; break;					//	res		4,c
			case 0xa2: reg_d = resregb(4, reg_d); reg_pc++; break;					//	res		4,d
			case 0xa3: reg_e = resregb(4, reg_e); reg_pc++; break;					//	res		4,e
			case 0xa4: reg_h = resregb(4, reg_h); reg_pc++; break;					//	res		4,h
			case 0xa5: reg_l = resregb(4, reg_l); reg_pc++; break;					//	res		4,l
			case 0xa6: writememb(reg_hl, resregb(4, readmemb(reg_hl)));reg_pc++;break;//res		4,(hl)
			case 0xa7: reg_a = resregb(4, reg_a); reg_pc++; break;					//	res		4,a
			case 0xa8: reg_b = resregb(5, reg_b); reg_pc++; break;					//	res		5,b
			case 0xa9: reg_c = resregb(5, reg_c); reg_pc++; break;					//	res		5,c
			case 0xaa: reg_d = resregb(5, reg_d); reg_pc++; break;					//	res		5,d
			case 0xab: reg_e = resregb(5, reg_e); reg_pc++; break;					//	res		5,e
			case 0xac: reg_h = resregb(5, reg_h); reg_pc++; break;					//	res		5,h
			case 0xad: reg_l = resregb(5, reg_l); reg_pc++; break;					//	res		5,l
			case 0xae: writememb(reg_hl, resregb(5, readmemb(reg_hl)));reg_pc++;break;//res		5,(hl)
			case 0xaf: reg_a = resregb(5, reg_a); reg_pc++; break;					//	res		5,a
			case 0xb0: reg_b = resregb(6, reg_b); reg_pc++; break;					//	res		6,b
			case 0xb1: reg_c = resregb(6, reg_c); reg_pc++; break;					//	res		6,c
			case 0xb2: reg_d = resregb(6, reg_d); reg_pc++; break;					//	res		6,d
			case 0xb3: reg_e = resregb(6, reg_e); reg_pc++; break;					//	res		6,e
			case 0xb4: reg_h = resregb(6, reg_h); reg_pc++; break;					//	res		6,h
			case 0xb5: reg_l = resregb(6, reg_l); reg_pc++; break;					//	res		6,l
			case 0xb6: writememb(reg_hl, resregb(6, readmemb(reg_hl)));reg_pc++;break;//res		6,(hl)
			case 0xb7: reg_a = resregb(6, reg_a); reg_pc++; break;					//	res		6,a
			case 0xb8: reg_b = resregb(7, reg_b); reg_pc++; break;					//	res		7,b
			case 0xb9: reg_c = resregb(7, reg_c); reg_pc++; break;					//	res		7,c
			case 0xba: reg_d = resregb(7, reg_d); reg_pc++; break;					//	res		7,d
			case 0xbb: reg_e = resregb(7, reg_e); reg_pc++; break;					//	res		7,e
			case 0xbc: reg_h = resregb(7, reg_h); reg_pc++; break;					//	res		7,h
			case 0xbd: reg_l = resregb(7, reg_l); reg_pc++; break;					//	res		7,l
			case 0xbe: writememb(reg_hl, resregb(7, readmemb(reg_hl)));reg_pc++;break;//res		7,(hl)
			case 0xbf: reg_a = resregb(7, reg_a); reg_pc++; break;					//	res		7,a

			case 0xc0: reg_b = setregb(0, reg_b); reg_pc++; break;					//	set		0,b
			case 0xc1: reg_c = setregb(0, reg_c); reg_pc++; break;					//	set		0,c
			case 0xc2: reg_d = setregb(0, reg_d); reg_pc++; break;					//	set		0,d
			case 0xc3: reg_e = setregb(0, reg_e); reg_pc++; break;					//	set		0,e
			case 0xc4: reg_h = setregb(0, reg_h); reg_pc++; break;					//	set		0,h
			case 0xc5: reg_l = setregb(0, reg_l); reg_pc++; break;					//	set		0,l
			case 0xc6: writememb(reg_hl, setregb(0, readmemb(reg_hl)));reg_pc++;break;//set		0,(hl)
			case 0xc7: reg_a = setregb(0, reg_a); reg_pc++; break;					//	set		0,a
			case 0xc8: reg_b = setregb(1, reg_b); reg_pc++; break;					//	set		1,b
			case 0xc9: reg_c = setregb(1, reg_c); reg_pc++; break;					//	set		1,c
			case 0xca: reg_d = setregb(1, reg_d); reg_pc++; break;					//	set		1,d
			case 0xcb: reg_e = setregb(1, reg_e); reg_pc++; break;					//	set		1,e
			case 0xcc: reg_h = setregb(1, reg_h); reg_pc++; break;					//	set		1,h
			case 0xcd: reg_l = setregb(1, reg_l); reg_pc++; break;					//	set		1,l
			case 0xce: writememb(reg_hl, setregb(1, readmemb(reg_hl)));reg_pc++;break;//set		1,(hl)
			case 0xcf: reg_a = setregb(1, reg_a); reg_pc++; break;					//	set		1,a
			case 0xd0: reg_b = setregb(2, reg_b); reg_pc++; break;					//	set		2,b
			case 0xd1: reg_c = setregb(2, reg_c); reg_pc++; break;					//	set		2,c
			case 0xd2: reg_d = setregb(2, reg_d); reg_pc++; break;					//	set		2,d
			case 0xd3: reg_e = setregb(2, reg_e); reg_pc++; break;					//	set		2,e
			case 0xd4: reg_h = setregb(2, reg_h); reg_pc++; break;					//	set		2,h
			case 0xd5: reg_l = setregb(2, reg_l); reg_pc++; break;					//	set		2,l
			case 0xd6: writememb(reg_hl, setregb(2, readmemb(reg_hl)));reg_pc++;break;//set		2,(hl)
			case 0xd7: reg_a = setregb(2, reg_a); reg_pc++; break;					//	set		2,a
			case 0xd8: reg_b = setregb(3, reg_b); reg_pc++; break;					//	set		3,b
			case 0xd9: reg_c = setregb(3, reg_c); reg_pc++; break;					//	set		3,c
			case 0xda: reg_d = setregb(3, reg_d); reg_pc++; break;					//	set		3,d
			case 0xdb: reg_e = setregb(3, reg_e); reg_pc++; break;					//	set		3,e
			case 0xdc: reg_h = setregb(3, reg_h); reg_pc++; break;					//	set		3,h
			case 0xdd: reg_l = setregb(3, reg_l); reg_pc++; break;					//	set		3,l
			case 0xde: writememb(reg_hl, setregb(3, readmemb(reg_hl)));reg_pc++;break;//set		3,(hl)
			case 0xdf: reg_a = setregb(3, reg_a); reg_pc++; break;					//	set		3,a
			case 0xe0: reg_b = setregb(4, reg_b); reg_pc++; break;					//	set		4,b
			case 0xe1: reg_c = setregb(4, reg_c); reg_pc++; break;					//	set		4,c
			case 0xe2: reg_d = setregb(4, reg_d); reg_pc++; break;					//	set		4,d
			case 0xe3: reg_e = setregb(4, reg_e); reg_pc++; break;					//	set		4,e
			case 0xe4: reg_h = setregb(4, reg_h); reg_pc++; break;					//	set		4,h
			case 0xe5: reg_l = setregb(4, reg_l); reg_pc++; break;					//	set		4,l
			case 0xe6: writememb(reg_hl, setregb(4, readmemb(reg_hl)));reg_pc++;break;//set		4,(hl)
			case 0xe7: reg_a = setregb(4, reg_a); reg_pc++; break;					//	set		4,a
			case 0xe8: reg_b = setregb(5, reg_b); reg_pc++; break;					//	set		5,b
			case 0xe9: reg_c = setregb(5, reg_c); reg_pc++; break;					//	set		5,c
			case 0xea: reg_d = setregb(5, reg_d); reg_pc++; break;					//	set		5,d
			case 0xeb: reg_e = setregb(5, reg_e); reg_pc++; break;					//	set		5,e
			case 0xec: reg_h = setregb(5, reg_h); reg_pc++; break;					//	set		5,h
			case 0xed: reg_l = setregb(5, reg_l); reg_pc++; break;					//	set		5,l
			case 0xee: writememb(reg_hl, setregb(5, readmemb(reg_hl)));reg_pc++;break;//set		5,(hl)
			case 0xef: reg_a = setregb(5, reg_a); reg_pc++; break;					//	set		5,a
			case 0xf0: reg_b = setregb(6, reg_b); reg_pc++; break;					//	set		6,b
			case 0xf1: reg_c = setregb(6, reg_c); reg_pc++; break;					//	set		6,c
			case 0xf2: reg_d = setregb(6, reg_d); reg_pc++; break;					//	set		6,d
			case 0xf3: reg_e = setregb(6, reg_e); reg_pc++; break;					//	set		6,e
			case 0xf4: reg_h = setregb(6, reg_h); reg_pc++; break;					//	set		6,h
			case 0xf5: reg_l = setregb(6, reg_l); reg_pc++; break;					//	set		6,l
			case 0xf6: writememb(reg_hl, setregb(6, readmemb(reg_hl)));reg_pc++;break;//set		6,(hl)
			case 0xf7: reg_a = setregb(6, reg_a); reg_pc++; break;					//	set		6,a
			case 0xf8: reg_b = setregb(7, reg_b); reg_pc++; break;					//	set		7,b
			case 0xf9: reg_c = setregb(7, reg_c); reg_pc++; break;					//	set		7,c
			case 0xfa: reg_d = setregb(7, reg_d); reg_pc++; break;					//	set		7,d
			case 0xfb: reg_e = setregb(7, reg_e); reg_pc++; break;					//	set		7,e
			case 0xfc: reg_h = setregb(7, reg_h); reg_pc++; break;					//	set		7,h
			case 0xfd: reg_l = setregb(7, reg_l); reg_pc++; break;					//	set		7,l
			case 0xfe: writememb(reg_hl, setregb(7, readmemb(reg_hl)));reg_pc++;break;//set		7,(hl)
			case 0xff: reg_a = setregb(7, reg_a); reg_pc++; break;					//	set		7,a

			default: printf("Illigal command PC:%04X DT:%02X %02X\n",reg_pc, m0, m1); reg_pc++; break;
			}
			break;

		default:
			printf("Illigal command PC:%04X DT:%02X\n",reg_pc, m0); reg_pc++; break;
		}
	}
}

void portout(unsigned char port_o, unsigned char val)
{
	switch (port_o) {

		case 0x32:
			if (val & 0x40) {	/* gANZX[h */
				memacc.ramacc = r_ramex;
				memacc.ramsel = r_mainmem;
			} else {			/* ƗANZX[h 0xc000-0xffff  mainmem */
				memacc.ramacc = r_ramsp;
				memacc.ramsel = r_mainmem;
			}
			break;

		case 0x34:				/* gANZX[h */
								/* x g1 r1 b1 x g0 r0 b0 */
								/* 00:bit reset   01:bit set  */
								/* 10:bit reverse 11:bit hold */
			memacc.port0x34 = val;
			printf("bit access\n");
			break;

		case 0x35:				/* gANZX[h */
			memacc.port0x35 = val;
			if (val & 0x80) {	/* gANZX[h 0xc000-0xffff  vram_b/r/g */
				memacc.ramsel = r_vram_ex;
			} else {			/* gANZX[h 0xc000-0xffff  mainmem */
				memacc.ramsel = r_mainmem;
			}
			break;

		case 0x5c:				/* ƗANZX[h 0xc000-0xffff  vram_b */
			memacc.ramsel = r_vram_b;
			break;

		case 0x5d:				/* ƗANZX[h 0xc000-0xffff  vram_r */
			memacc.ramsel = r_vram_r;
			break;

		case 0x5e:				/* ƗANZX[h 0xc000-0xffff  vram_g */
			memacc.ramsel = r_vram_g;
			break;

		case 0x5f:				/* ƗANZX[h 0xc000-0xffff  mainmem */
			memacc.ramsel = r_mainmem;
			break;

		default:
			break;
	}
}

unsigned char readmemb(unsigned short int add)
{
	if (add < 0xc000 || memacc.ramsel == r_mainmem) {
		return memacc.mainmem[add];
	}

	add -= 0xc000;
	switch (memacc.ramsel) {
		case r_vram_b: return memacc.vram_b[add];
		case r_vram_r: return memacc.vram_r[add];
		case r_vram_g: return memacc.vram_g[add];
	}

	return 0;
}

unsigned short int readmemw(unsigned short int add)
{
	return ( readmemb(add) + readmemb(add+1)*0x100 );
}

void writememb(unsigned short int add, unsigned char val)
{

/* debug */
/*
if (
	(add == 0x852f)
) {
	printf("register\n");
	printf(" AF :%04X   BC :%04X   DE :%04X   HL :%04X\n",reg_af, reg_bc, reg_de, reg_hl);
	printf(" AF':%04X   BC':%04X   DE':%04X   HL':%04X\n",reg_af_,reg_bc_,reg_de_,reg_hl_);
	printf(" IX :%04X   IY :%04X   PC :%04X   SP :%04X\n",reg_ix, reg_iy, reg_pc, reg_sp);
	printf("(HL):%04X  (BC):%04X  (DE):%04X  (SP):%04X\n",
		readmemw(reg_hl), readmemw(reg_bc), readmemw(reg_de), readmemw(reg_sp) );
}
*/

	if (add < 0xc000 || memacc.ramsel == r_mainmem) {
		memacc.mainmem[add] = val;
		return;
	}

	add -= 0xc000;
	switch (memacc.ramsel) {
		case r_vram_b: memacc.vram_b[add] = val; return;
		case r_vram_r: memacc.vram_r[add] = val; return;
		case r_vram_g: memacc.vram_g[add] = val; return;
	}

	return;
}

void writememw(unsigned short int add, unsigned short int val)
{
	writememb(add+0, (val & 0x00ff) );
	writememb(add+1, (val & 0xff00) >> 8 );
}

unsigned char readmemixb(unsigned char ixy, unsigned short int ptr)
{
	unsigned short int add;
	unsigned short ptr_val;
	unsigned char ptr_dt;

	ptr_dt = readmemb(ptr);
	ptr_val = (ptr_dt >= 0x80) ? (0xff00 + ptr_dt) : (0x0000 + ptr_dt);
	add = (ixy == 0xdd) ? reg_ix + ptr_val : reg_iy + ptr_val;

	return readmemb(add);
}

void writememixb(unsigned char ixy, unsigned short int ptr, unsigned char val)
{
	unsigned short int add;
	unsigned short ptr_val;
	unsigned char ptr_dt;

	ptr_dt = readmemb(ptr);
	ptr_val = (ptr_dt >= 0x80) ? (0xff00 + ptr_dt) : (0x0000 + ptr_dt);
	add = (ixy == 0xdd) ? reg_ix + ptr_val : reg_iy + ptr_val;

	writememb(add, val);
}

void setixy(unsigned char ixy, unsigned short int val)
{
	if (ixy == 0xdd) {
		reg_ix = val;
	} else {
		reg_iy = val;
	}
}

unsigned short int reladd(unsigned short int ptr)
{
	unsigned short ptr_val;
	unsigned char ptr_dt;

	ptr_dt = readmemb(ptr);
	ptr_val = (ptr_dt >= 0x80) ? (0xff00 + ptr_dt) : (0x0000 + ptr_dt);

	return (reg_pc + 2 + ptr_val);
}

void setcflag(void)
{
	reg_f = (reg_f | 0x01);
}

void clrcflag(void)
{
	reg_f = (reg_f & 0xfe);
}

void setzflag(void)
{
	reg_f = (reg_f | 0x40);
}

void clrzflag(void)
{
	reg_f = (reg_f & 0xbf);
}

void addregb(unsigned char val)
{
	unsigned short int tmp_val;

	tmp_val = (unsigned short int)reg_a + (unsigned short int)val;

	if (tmp_val & 0xff00) {
		setcflag();
	} else {
		clrcflag();
	}

	if (tmp_val & 0x00ff) {
		clrzflag();
	} else {
		setzflag();
	}

	reg_a = (unsigned char)(tmp_val & 0x00ff);
}

void adcregb(unsigned char val)
{
	unsigned short int tmp_val;

	tmp_val = (unsigned short int)reg_a + (unsigned short int)val;
	if (is_cflag) {
		tmp_val ++;
	}

	if (tmp_val & 0xff00) {
		setcflag();
	} else {
		clrcflag();
	}

	if (tmp_val & 0x00ff) {
		clrzflag();
	} else {
		setzflag();
	}

	reg_a = (unsigned char)(tmp_val & 0x00ff);
}

void subregb(unsigned char val)
{
	unsigned short int tmp_val;

	tmp_val = (unsigned short int)reg_a - (unsigned short int)val;

	if (tmp_val & 0xff00) {
		setcflag();
	} else {
		clrcflag();
	}

	if (tmp_val & 0x00ff) {
		clrzflag();
	} else {
		setzflag();
	}

	reg_a = (unsigned char)(tmp_val & 0x00ff);
}

void sbcregb(unsigned char val)
{
	unsigned short int tmp_val;

	tmp_val = (unsigned short int)reg_a - (unsigned short int)val;
	if (is_cflag) {
		tmp_val --;
	}

	if (tmp_val & 0xff00) {
		setcflag();
	} else {
		clrcflag();
	}

	if (tmp_val & 0x00ff) {
		clrzflag();
	} else {
		setzflag();
	}

	reg_a = (unsigned char)(tmp_val & 0x00ff);
}

void andregb(unsigned char val)
{
	reg_a = reg_a & val;

	clrcflag();

	if (reg_a) {
		clrzflag();
	} else {
		setzflag();
	}
}

void orregb(unsigned char val)
{
	reg_a = reg_a | val;

	clrcflag();

	if (reg_a) {
		clrzflag();
	} else {
		setzflag();
	}
}

void xorregb(unsigned char val)
{
	reg_a = reg_a ^ val;

	clrcflag();

	if (reg_a) {
		clrzflag();
	} else {
		setzflag();
	}
}

void cpregb(unsigned char val)
{
	unsigned short int tmp_val;

	tmp_val = (unsigned short int)reg_a - (unsigned short int)val;

	if (tmp_val & 0xff00) {
		setcflag();
	} else {
		clrcflag();
	}

	if (tmp_val & 0x00ff) {
		clrzflag();
	} else {
		setzflag();
	}
}

void rlcaregb(void)
{
	unsigned short int tmp_val;

	if (reg_a & 0x80) {
		tmp_val = (unsigned short int)reg_a * 2 + 1;
		setcflag();
	} else {
		tmp_val = (unsigned short int)reg_a * 2;
		clrcflag();
	}

	reg_a = (unsigned char)(tmp_val & 0x00ff);
}

void rrcaregb(void)
{
	unsigned short int tmp_val;

	if (reg_a & 0x01) {
		tmp_val = (unsigned short int)reg_a / 2 + 0x0080;
		setcflag();
	} else {
		tmp_val = (unsigned short int)reg_a / 2;
		clrcflag();
	}

	reg_a = (unsigned char)(tmp_val & 0x00ff);
}

void rlaregb(void)
{
	unsigned short int tmp_val;

	if (is_cflag) {
		tmp_val = (unsigned short int)reg_a * 2 + 1;
	} else {
		tmp_val = (unsigned short int)reg_a * 2;
	}

	if (reg_a & 0x80) {
		setcflag();
	} else {
		clrcflag();
	}

	reg_a = (unsigned char)(tmp_val & 0x00ff);
}

void rraregb(void)
{
	unsigned short int tmp_val;

	if (is_cflag) {
		tmp_val = (unsigned short int)reg_a / 2 + 0x0080;
	} else {
		tmp_val = (unsigned short int)reg_a / 2;
	}

	if (reg_a & 0x01) {
		setcflag();
	} else {
		clrcflag();
	}

	reg_a = (unsigned char)(tmp_val & 0x00ff);
}

unsigned char rlcregb(unsigned char val)
{
	unsigned short int tmp_val;

	if (val & 0x80) {
		tmp_val = (unsigned short int)val * 2 + 1;
		setcflag();
	} else {
		tmp_val = (unsigned short int)val * 2;
		clrcflag();
	}

	if (tmp_val & 0x00ff) {
		clrzflag();
	} else {
		setzflag();
	}
	return ( (unsigned char)(tmp_val & 0x00ff) );
}

unsigned char rrcregb(unsigned char val)
{
	unsigned short int tmp_val;

	if (val & 0x01) {
		tmp_val = (unsigned short int)val / 2 + 0x80;
		setcflag();
	} else {
		tmp_val = (unsigned short int)val / 2;
		clrcflag();
	}

	if (tmp_val & 0x00ff) {
		clrzflag();
	} else {
		setzflag();
	}

	return ( (unsigned char)(tmp_val & 0x00ff) );
}

unsigned char rlregb(unsigned char val)
{
	unsigned short int tmp_val;

	if (is_cflag) {
		tmp_val = (unsigned short int)val * 2 + 1;
	} else {
		tmp_val = (unsigned short int)val * 2;
	}

	if (val & 0x80) {
		setcflag();
	} else {
		clrcflag();
	}

	if (tmp_val & 0x00ff) {
		clrzflag();
	} else {
		setzflag();
	}

	return ( (unsigned char)(tmp_val & 0x00ff) );
}

unsigned char rrregb(unsigned char val)
{
	unsigned short int tmp_val;

	if (is_cflag) {
		tmp_val = (unsigned short int)val / 2 + 0x80;
	} else {
		tmp_val = (unsigned short int)val / 2;
	}

	if (val & 0x01) {
		setcflag();
	} else {
		clrcflag();
	}

	if (tmp_val & 0x00ff) {
		clrzflag();
	} else {
		setzflag();
	}

	return ( (unsigned char)(tmp_val & 0x00ff) );
}

unsigned char slaregb(unsigned char val)
{
	unsigned short int tmp_val;

	tmp_val = (unsigned short int)val * 2;

	if (val & 0x80) {
		setcflag();
	} else {
		clrcflag();
	}

	if (tmp_val & 0x00ff) {
		clrzflag();
	} else {
		setzflag();
	}

	return ( (unsigned char)(tmp_val & 0x00ff) );
}

unsigned char sraregb(unsigned char val)
{
	unsigned short int tmp_val;

	if (tmp_val & 0x80) {
		tmp_val = (unsigned short int)val / 2 + 0x80;
	} else {
		tmp_val = (unsigned short int)val / 2;
	}

	if (val & 0x01) {
		setcflag();
	} else {
		clrcflag();
	}

	if (tmp_val & 0x00ff) {
		clrzflag();
	} else {
		setzflag();
	}

	return ( (unsigned char)(tmp_val & 0x00ff) );
}

unsigned char srlregb(unsigned char val)
{
	unsigned short int tmp_val;

	tmp_val = (unsigned short int)val / 2;

	if (val & 0x01) {
		setcflag();
	} else {
		clrcflag();
	}

	if (tmp_val & 0x00ff) {
		clrzflag();
	} else {
		setzflag();
	}

	return ( (unsigned char)(tmp_val & 0x00ff) );
}

unsigned char incregb(unsigned char val)
{
	unsigned short int tmp_val;

	tmp_val =  (unsigned short int)val + 1;

	if (tmp_val & 0x00ff) {
		clrzflag();
	} else {
		setzflag();
	}

	return ( (unsigned char)(tmp_val & 0x00ff) );
}

unsigned char decregb(unsigned char val)
{
	unsigned short int tmp_val;

	tmp_val =  (unsigned short int)val - 1;

	if (tmp_val & 0x00ff) {
		clrzflag();
	} else {
		setzflag();
	}

	return ( (unsigned char)(tmp_val & 0x00ff) );
}

unsigned short int addregw(unsigned short int val1, unsigned short int val2)
{
	unsigned int tmp_val;

	tmp_val = (unsigned int)val1 + (unsigned int)val2;

	if (tmp_val & 0xffff0000) {
		setcflag();
	} else {
		clrcflag();
	}

	return ( (unsigned short int)(tmp_val & 0x0000ffff) );
}

unsigned short int adcregw(unsigned short int val1, unsigned short int val2)
{
	unsigned int tmp_val;

	tmp_val = (unsigned int)val1 + (unsigned int)val2;
	if (is_cflag) {
		tmp_val ++;
	}

	if (tmp_val & 0xffff0000) {
		setcflag();
	} else {
		clrcflag();
	}

	if (tmp_val & 0x0000ffff) {
		clrzflag();
	} else {
		setzflag();
	}

	return ( (unsigned short int)(tmp_val & 0x0000ffff) );
}

unsigned short int sbcregw(unsigned short int val1, unsigned short int val2)
{
	unsigned int tmp_val;

	tmp_val = (unsigned int)val1 - (unsigned int)val2;
	if (is_cflag) {
		tmp_val --;
	}

	if (tmp_val & 0xffff0000) {
		setcflag();
	} else {
		clrcflag();
	}

	if (tmp_val & 0x0000ffff) {
		clrzflag();
	} else {
		setzflag();
	}

	return ( (unsigned short int)(tmp_val & 0x0000ffff) );
}

unsigned short int incregw(unsigned short int val)
{
	unsigned int tmp_val;

	tmp_val = (unsigned int)val + 1;

	return ( (unsigned short int)(tmp_val & 0x0000ffff) );
}

unsigned short int decregw(unsigned short int val)
{
	unsigned int tmp_val;

	tmp_val = (unsigned int)val - 1;

	return ( (unsigned short int)(tmp_val & 0x0000ffff) );
}

void bitregb(unsigned char b_n, unsigned char val)
{
	unsigned char mask;

	switch (b_n) {
		case 0: mask = 0x01; break;
		case 1: mask = 0x02; break;
		case 2: mask = 0x04; break;
		case 3: mask = 0x08; break;
		case 4: mask = 0x10; break;
		case 5: mask = 0x20; break;
		case 6: mask = 0x40; break;
		case 7: mask = 0x80; break;
		default:mask = 0x00; break;
	}

	if (val & mask) {
		clrzflag();
	} else {
		setzflag();
	}

}

unsigned char resregb(unsigned char b_n, unsigned char val)
{
	unsigned char mask;

	switch (b_n) {
		case 0: mask = 0xfe; break;
		case 1: mask = 0xfd; break;
		case 2: mask = 0xfb; break;
		case 3: mask = 0xf7; break;
		case 4: mask = 0xef; break;
		case 5: mask = 0xdf; break;
		case 6: mask = 0xbf; break;
		case 7: mask = 0x7f; break;
		default:mask = 0xff; break;
	}

	return (val & mask);
}

unsigned char	setregb(unsigned char b_n, unsigned char val)
{
	unsigned char mask;

	switch (b_n) {
		case 0: mask = 0x01; break;
		case 1: mask = 0x02; break;
		case 2: mask = 0x04; break;
		case 3: mask = 0x08; break;
		case 4: mask = 0x10; break;
		case 5: mask = 0x20; break;
		case 6: mask = 0x40; break;
		case 7: mask = 0x80; break;
		default:mask = 0x00; break;
	}

	return (val | mask);
}

