/****************************************************/
/* N88-BASIC(DOS) to file                           */
/****************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	S_LEN		16
#define	SECLEN		0x100
#define	MAXSEC		16
#define	MAXTRACK	80
#define	TRACKBYTE	0x1000
#define	FILEOFFSET	(0x12*2+1)*TRACKBYTE+0x00*SECLEN
#define	CLASTERSIZE	0x0800
#define	CLOFFSET	(0x12*2+1)*TRACKBYTE+0x0d*SECLEN

/*
CHRN=12:01:01:01`12:01:0c:01
t@CXg

CHRN=12:01:0d:01
ID

CHRN=12:01:0e:01`12:01:10:01
FAT

*/

int main(int argc, char **argv)
{
	unsigned char	diskimg[MAXTRACK*TRACKBYTE];
	char	outbody[S_LEN],outext[S_LEN],outfile[S_LEN];
	FILE	*infp, *outfp;
	int		num,c,i,j,k,secno;
	int		fileno,fileptr;
	int		flag;
	int		claster,clsize,nextcl;
	int		a0,a1,a2,a3;

	if (argc != 2) {
		fprintf(stderr, "Usage: n88tofile infile\n");
		exit(1);
	}


/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	fseek(infp,0x20,SEEK_SET);

	a0 = fgetc(infp);
	a1 = fgetc(infp);
	a2 = fgetc(infp);
	a3 = fgetc(infp);

/* D88̐擪wb_ǂݔ΂ */
	fseek(infp,a3*0x1000000+a2*0x10000+a1*0x100+a0,SEEK_SET);


	for (i = 0;i < MAXTRACK;i ++) {

		for (j = 0;j < MAXSEC;j ++) {
			secno = j + 1;

	/* D88̃ZN^Ƃ̃wb_ */
			for (k = 0;k < 16;k ++) {
				if ((c = fgetc(infp)) == EOF) {
					printf("Data illigal\n");
					exit(1);
				}
			}
			for (k = 0;k < SECLEN;k ++) {
				if ((c = fgetc(infp)) == EOF) {
					printf("Data illigal\n");
					exit(1);
				}
				diskimg[i*TRACKBYTE+(secno-1)*SECLEN+k] = (unsigned char)c;
			}
		}

	}


/* file generate */

	fileno = 0;

	for (;;) {
		fileptr = fileno * 0x10 + FILEOFFSET;
		c = diskimg[fileptr];
		if (c == 0xff) {
			break;
		}
		if (fileno == 0x30) {
			break;
		}

		for (i = 0;i < 6;i ++) {
			outbody[i] = diskimg[fileptr + i];
		}
		for (i = 0;i < 3;i ++) {
			outext[i]  = diskimg[fileptr + 6 + i];
		}

		for (i = 0,j = 0;i < 6;i ++,j++) {
			c = outbody[i];
			if (c == 0x20) {
				break;
			}
			outfile[j] = c;
		}

		if (outext[0] != 0x20) {

			outfile[j] = '.';
			j ++;

			for (i = 0;i < 3;i ++,j++) {
				c = outext[i];
				if (c == 0x20) {
					break;
				}
				outfile[j] = c;
			}
		}
		outfile[j] = 0x00;
		printf("Generate file : %s\n",outfile);

		if ((outfp = fopen(outfile, "wb")) == NULL) {
			perror(outfile);
			exit(1);
		}

		claster = diskimg[fileptr + 10];

		for (;;) {

			nextcl = diskimg[claster + CLOFFSET];

			if (nextcl == 0xff || nextcl == 0xfe) {
				break;
			}

			/* NX^TCYZo */

			clsize = CLASTERSIZE;
			if ((nextcl & 0xf0) == 0xc0) {
				clsize = 0x100 * (nextcl & 0x0f);
			}

			for (i = 0;i < clsize;i ++ ) {
				fputc(diskimg[claster * CLASTERSIZE + i],outfp);
			}

			if ((nextcl & 0xf0) == 0xc0) {
				break;
			}
			claster = nextcl;
		}

		fclose(outfp);
		fileno ++;

	}


	fclose(infp);


	return(0);
}
